//=============================================================================
// (c) Copyright 2014 Diamond Systems Corporation. Use of this source code
// is subject to the terms of Diamond Systems' Software License Agreement.
// Diamond Systems provides no warranty of proper performance if this
// source code is modified.
//
// File: dsc-can4lp-xt-linux.c  v1.00
//
// Depedency :	Standalone driver
//============================================================================

#include <linux/kernel.h>	/* We're doing kernel work */
#include<linux/init.h>
#include<linux/module.h>
#include<linux/moduleparam.h>
#include<linux/pci.h>
#include<linux/netdevice.h>
#include<linux/etherdevice.h>
#include<linux/irq.h>
#include<linux/interrupt.h>
#include<linux/skbuff.h>
#include<linux/delay.h>
#include<linux/spinlock.h>

#include <asm/io.h>
//#include <linux/sysdev.h>
#include <linux/sysfs.h>
#include <linux/delay.h>
#include <linux/clk.h>
#include <linux/wait.h>
#include <linux/major.h>
#include <linux/uaccess.h>
#include <linux/sched.h>
#include <asm/signal.h>
#include"dsc-can4lp-xt-linux.h"

int flag =1;

// value to check for wait/wake method
int rd_Wake_up_fake_Cond_0  = 0 ;
int Wake_up_fake_Cond_0  = 0 ;
int Wake_up_fake_Cond_1  = 0 ;
int Wake_up_fake_Cond_2  = 0 ;
int Wake_up_fake_Cond_3  = 0 ;

#define LOG(string...) printk(KERN_NOTICE string)

#define ISA_DRV_NAME	"ISA-CAN"

#define DRV_NAME	"PCI-CAN"
#define DEV_NAME	"pci_fpga"

#define ISA_DRV_MAJOR	231

#define DRV_MAJOR	230
#define RW_BUF_SIZE	256

#define MAX_DEV_SUPPORT		4


#define PCICAN_VENDER_ID        0x4453
#define PCICAN_DEVICE_ID        0x0a00

static void *bar_base_addr;
static void *dio_base_addr = NULL;
unsigned char dio_config_val=0 ;
unsigned char dio_port_A=0 ;
unsigned char dio_port_B=0 ;
static void *dio_baddr = 0;
static void * fpga_board_addr = 0;
static int  isa_fpga_board_addr = 0;
can_dev candev;

static int init_isa(void);

void *baseaddr[MAX_DEV_SUPPORT];
unsigned int isabaseaddr[MAX_DEV_SUPPORT];
static int irq ;
static int mode = 2;
static int isa_base_addr_val ;
static int isa_dio_base_addr ;
module_param(irq, int, 0);
MODULE_PARM_DESC(irq, "DSC_CAN4LP_XT_MODE");

//module_param(isa_base_addr_val,int, 0);
//MODULE_PARM_DESC(isa_base_addr_val, "DSC_CAN4LP_XT_MODE");

module_param(mode, int, 0);
MODULE_PARM_DESC(mode, "DSC_CAN4LP_XT_MODE");


//module_param(isa_dio_base_addr, int, 0);
//MODULE_PARM_DESC(isa_dio_base_addr, "DSC_CAN4LP_XT_MODE");

//Datareceive function for ISA CAN0
void Datareceive0(int can,can_dev *candev_p);
//Datareceive function for ISA CAN1
void Datareceive1(int can,can_dev *candev_p);
//Datareceive function for ISA CAN2
void Datareceive2(int can,can_dev *candev_p);
//Datareceive function for ISA CAN3
void Datareceive3(int can,can_dev *candev_p);

//ISA ISR handler
static irqreturn_t JNMM_ISA_Handler(int irq, void *dev_id);
//PCI ISR handler
static irqreturn_t JNMM_PCI_Handler(int irq, void *dev_id);

void pci_can_tx_port(PCANMESSAGE pTXCANMessage);
/////////////////////////////////////////////////////////////////////////////////////////
//
//DIOA_read
//Description:
//
// This function read the DIO for  Port A for PCI/ISA
//
//Return:
// Read  the DIO for PORT A
///////////////////////////////////////////////////////////////////////////////////////
static ssize_t DIOA_read(struct kobject *kobj, struct kobj_attribute *attr,
                char *buf)
{
	if(mode == ISA_MODE)
	{
		dio_port_A = inb(isa_dio_base_addr+DIO_PORT_A) ;
		//printk("ISA_MODE isa_dio_base_addr %x porta read \n",isa_dio_base_addr);	
	}
	else
		dio_port_A = readb((dio_baddr + (0*4))) ;
	//printk(KERN_INFO "dio_port_A = 0x%x\n",dio_port_A);
	return  sprintf(buf, "0x%02x\n", dio_port_A);
}
/////////////////////////////////////////////////////////////////////////////////////////
//
//DIOA_write
//Description:
//
// This function write  the DIO for  Port A for PCI/ISA
//
//Return:
// Write  the DIO for PORT A
///////////////////////////////////////////////////////////////////////////////////////
static ssize_t DIOA_write(struct kobject *kobj, struct kobj_attribute *attr,
                const char *buf, size_t count)
{
	//static int i = 0 ;
	sscanf(buf, "%x", &dio_port_A);
	if(mode == ISA_MODE)
	{
		outb(dio_port_A, (isa_dio_base_addr+DIO_PORT_A));
		//printk("ISA_MODE isa_dio_base_addr %x porta write \n",isa_dio_base_addr);	
	}
	else
		writeb(dio_port_A, (dio_baddr + (0*4))) ;
	//outb(dio_port_A, (dio_base_addr+i)) ;
	//printk("Addr = %x\n", (dio_base_addr+DIO_PORT_A));
	return count;
}
/////////////////////////////////////////////////////////////////////////////////////////
//
//DIOB_read
//Description:
//
// This function read the DIO for  Port B for PCI/ISA
//
//Return:
// Read  the DIO for PORT B
///////////////////////////////////////////////////////////////////////////////////////
static ssize_t DIOB_read(struct kobject *kobj, struct kobj_attribute *attr,
                char *buf)
{
	if(mode== ISA_MODE)
	{	
		dio_port_B = inb(isa_dio_base_addr+DIO_PORT_B) ;
		//printk("isa_dio_base_addr %x ISA_MODE portB Read \n",isa_dio_base_addr);		
	}	
	else
		dio_port_B = readb((dio_baddr + (1*4))) ;
	//printk(KERN_INFO "dio_port_B = 0x%x\n",dio_port_B);
	return  sprintf(buf, "0x%02x\n", dio_port_B);

}
/////////////////////////////////////////////////////////////////////////////////////////
//
//DIOB_write
//Description:
//
// This function read the DIO for  Port B for PCI/ISA
//
//Return:
// Read  the DIO for PORT B
///////////////////////////////////////////////////////////////////////////////////////
static ssize_t DIOB_write(struct kobject *kobj, struct kobj_attribute *attr,
                const char *buf, size_t count)
{
	sscanf(buf, "%x", &dio_port_B);
	if(mode== ISA_MODE)
	{	
		outb(dio_port_B, (isa_dio_base_addr+DIO_PORT_B)) ;
		//printk("ISA_MODE isa_dio_base_addr %x portB write \n",isa_dio_base_addr);			
	}
	else
		writeb(dio_port_B, (dio_baddr + (1*4))) ;
	//printk("Addr = %x\n", (dio_base_addr+DIO_PORT_B));
	return count;
}

/////////////////////////////////////////////////////////////////////////////////////////
//
//fpga_ver_read
//Description:
//
// This function read the FPGA Version for PCI/ISA
//
//Return:
// Read  the FPGA version 
///////////////////////////////////////////////////////////////////////////////////////
static ssize_t fpga_ver_read(struct kobject *kobj, struct kobj_attribute *attr,
                char *buf)
{
	unsigned char val ;
	unsigned short fpga_ver ;
	if(mode== ISA_MODE)
	{
		val = inb(isa_fpga_board_addr + FPGA_MAJOR_VER) ;
		fpga_ver = (val <<8) ;
		val = inb(isa_fpga_board_addr + FPGA_MINOR_VER) ;
		fpga_ver = fpga_ver | val  ;
		//printk("fpga_ver %x\n",fpga_ver);
	}
	else
	{
		val = readb(fpga_board_addr + (FPGA_MAJOR_VER*4 )) ;
		fpga_ver = (val <<8) ;
		val = readb(fpga_board_addr + (FPGA_MINOR_VER*4 )) ;
		fpga_ver = fpga_ver | val  ;
	}
	return  sprintf(buf, "%hu\n", fpga_ver);
}
/////////////////////////////////////////////////////////////////////////////////////////
//
//board_ver_read
//Description:
//
// This function read the Board Version for PCI/ISA
//
//Return:
// Read  the board  version value 
///////////////////////////////////////////////////////////////////////////////////////
static ssize_t board_ver_read(struct kobject *kobj, struct kobj_attribute *attr,
                const char *buf, size_t count)
{
	unsigned char val ;
	unsigned short board_ver ;
	if(mode== ISA_MODE)
	{
		val = inb(isa_fpga_board_addr + BOARD_MAJOR_VER) ;
		board_ver = (val <<8) ;
		val = inb(isa_fpga_board_addr + BOARD_MINOR_VER) ;
		board_ver = board_ver | val  ;
		//printk("board_ver %x\n",board_ver);
	}
	else
	{
		val = readb((fpga_board_addr + (BOARD_MAJOR_VER*4 ))) ;
		board_ver = (val <<8) ;
		val = readb((fpga_board_addr + (BOARD_MINOR_VER*4 ))) ;
		board_ver = board_ver | val  ;
	}
	return  sprintf(buf, "%hu\n", board_ver);
}
/////////////////////////////////////////////////////////////////////////////////////////
//
//DataDequeue3
//Description:
//
// This function read the CAN data  of CAN Port 3 from the Queus  for PCI/ISA
//
//Return:
// Read  the CAN data of CAN Port 3 
///////////////////////////////////////////////////////////////////////////////////////
int DataDequeue3(can_dev *candev_p,unsigned char *data)
{
	if(candev_p->Front3 == candev_p->Rear3) 
	{
	    return -1;
	}

	memcpy(data,candev_p->Q3[candev_p->Front3],16);

	candev_p->Front3++;

	if(candev_p->Front3 > MAXQ)
			candev_p->Front3 = 0;

	return 16;
}
/////////////////////////////////////////////////////////////////////////////////////////
//
//DataDequeue2
//Description:
//
// This function read the CAN data  of CAN Port 2 from the Queus for PCI/ISA
//
//Return:
// Read  the CAN data of CAN Port 2 
///////////////////////////////////////////////////////////////////////////////////////
int DataDequeue2(can_dev *candev_p,unsigned char *data)
{
	if(candev_p->Front2 == candev_p->Rear2) 
	{
	    return -1;
	}

	memcpy(data,candev_p->Q2[candev_p->Front2],16);

	candev_p->Front2++;

	if(candev_p->Front2 > MAXQ)
			candev_p->Front2 = 0;

	return 16;
}
/////////////////////////////////////////////////////////////////////////////////////////
//
//DataDequeue1
//Description:
//
// This function read the CAN data  of CAN Port 1 from the Queus for PCI/ISA
//
//Return:
// Read  the CAN data of CAN Port 1 
///////////////////////////////////////////////////////////////////////////////////////
int DataDequeue1(can_dev *candev_p,unsigned char *data)
{
	if(candev_p->Front1 == candev_p->Rear1) 
	{
	    return -1;
	}

	memcpy(data,candev_p->Q1[candev_p->Front1],16);

	candev_p->Front1++;

	if(candev_p->Front1 > MAXQ)
		candev_p->Front1 = 0;


	return 16;
}
/////////////////////////////////////////////////////////////////////////////////////////
//
//DataDequeue0
//Description:
//
// This function read the CAN data  of CAN Port 0 from the Queus for PCI/ISA
//
//Return:
// Read  the CAN data of CAN Port 0 
///////////////////////////////////////////////////////////////////////////////////////
int DataDequeue0(can_dev *candev_p,unsigned char *data)
{
	if(candev_p->Front0 == candev_p->Rear0) 
	{
	    return -1;
	}

	memcpy(data,candev_p->Q0[candev_p->Front0],16);

	candev_p->Front0++;

	if(candev_p->Front0 > MAXQ)
		candev_p->Front0 = 0;


	return 16;
}
/////////////////////////////////////////////////////////////////////////////////////////
//
//CAN_Reset_mode
//Description:
//
// This function reset  the CAN device PCI for CAN(0-3) based on the CAN Port selected 
//
//Return:
// void
///////////////////////////////////////////////////////////////////////////////////////
void CAN_Reset_mode(void * base_addr)
{
	int i;
	unsigned char status = readb(base_addr+(CFG_STAT * 4));
	//Disable the interrupt
	writel(0x00, (base_addr+(RTIE * 4))) ;
	
	//Reset mode
	for(i = 0; i < 100; i++) {
		/* Check Reset bit */
		if (status & 0x80) {
			return;
		}
		writel(0x80, (base_addr+(CFG_STAT * 4))) ;	
		udelay(10);

		status = readb(base_addr+(CFG_STAT * 4));
	}
}
/////////////////////////////////////////////////////////////////////////////////////////
//
//CAN_Normal_mode
//Description:
//
// This function reset the device into normal mode of  the CAN device PCI for CAN(0-3) based on the CAN Port selected 
//
//Return:
// void
///////////////////////////////////////////////////////////////////////////////////////
void CAN_Normal_mode(void * base_addr)
{
	int i;
	unsigned char status = readb(base_addr+(CFG_STAT * 4));
	
	
	//Reset mode
	for(i = 0; i < 100; i++) {
		/* Check Reset bit */
		if ((status & 0x80)==0) {
			writel(0xFF, (base_addr+(RTIE * 4))); //Enable Interrupts
			return;
		}
		writel(0x00, (base_addr+(CFG_STAT * 4))) ;	
		udelay(10);

		status = readb(base_addr+(CFG_STAT * 4));
	}
}
/////////////////////////////////////////////////////////////////////////////////////////
//
//pci_can_init
//Description:
//
// This function initialize  the CAN device PCI for CAN(0-3) based on the CAN Port selected 
//
//Return:
// return zero 
///////////////////////////////////////////////////////////////////////////////////////
static int pci_can_init(void * base_addr)
{
	writel(0x80, (base_addr+(CFG_STAT * 4))) ;
	writel(0x00, (base_addr+(CFG_STAT * 4))) ;
	/* Clear error counters and error code capture */
	writel(0x00, (base_addr+(TECNT * 4))) ;
	writel(0x00, (base_addr+(RECNT * 4))) ;
	readl(base_addr+(EALCAP * 4)) ;

	writel(0x4B, (base_addr+(LIMIT * 4))) ;
	writel(0xFF, (base_addr+(RTIE * 4))) ;
	writel(0x1A, (base_addr+(ERRINT * 4))) ;
	return 0;
}
/////////////////////////////////////////////////////////////////////////////////////////
//
//JNMM_PCI_RESET
//Description:
//
// This function reset the device to normal mode for  the CAN device PCI for CAN(0-3) based on the CAN Port selected 
//
//Return:
// void 
///////////////////////////////////////////////////////////////////////////////////////
void JNMM_PCI_RESET(void * base_addr)
{
	
	CAN_Reset_mode(base_addr);

	readb(base_addr+(EALCAP * 4)); // Read arbitration lost capture
	CAN_Normal_mode(base_addr);
	
	//pci_can_init(base_addr);
}
/////////////////////////////////////////////////////////////////////////////////////////
//
//can_init
//Description:
//
// This function initialize  CAN device ISA for CAN(0-3) based on the CAN Port selected 
//
//Return:
// void 
///////////////////////////////////////////////////////////////////////////////////////
static int can_init(unsigned int base_addr)
{
	outb(0x80, (base_addr+(CFG_STAT))) ;
	outb(0x00, (base_addr+(CFG_STAT))) ;
	outb(0x4B, (base_addr+(LIMIT))) ;
	outb(0xFF, (base_addr+(RTIE))) ;
	outb(0x1A, (base_addr+(ERRINT))) ;
	Wake_up_fake_Cond_0 = 0 ;
	Wake_up_fake_Cond_1 = 0 ;
	Wake_up_fake_Cond_2 = 0 ;
	Wake_up_fake_Cond_3 = 0 ;
	return 0;
}
/////////////////////////////////////////////////////////////////////////////////////////
//
//DataEmpty
//Description:
//
// This function empty the Queue maintained in the device context for  the CAN device ISA/PCI for CAN(0-3) 
//
//Return:
// void 
///////////////////////////////////////////////////////////////////////////////////////
void DataEmpty(can_dev *candev_p)
{
	int i,j;	
	for(i=0;i<MAXQ;i++)
	for(j = 0; j < 15; j++)
	{
		candev_p->Q0[i][j] = 0;
		candev_p->Q1[i][j] = 0;
		candev_p->Q2[i][j] = 0;
		candev_p->Q3[i][j] = 0;
	}

	for(i=0;i<4;i++)
	memset(&(candev_p->can_stats[i]),0,sizeof(can_device_stats));
}
/////////////////////////////////////////////////////////////////////////////////////////
//
//pci_err_intr
//Description:
//
// This function read the error status for  CAN device PCI for CAN(0-3) based on the CAN Port selected 
//
//Return:
// void 
///////////////////////////////////////////////////////////////////////////////////////
void pci_err_intr(can_dev *candev_p,int can,unsigned char ErrIntr )
{
	unsigned char Ewarn,RError,TError,err_cap;
	 
	if(ErrIntr & 0x80 ) // Error warning state
	{
		Ewarn = readb(baseaddr[can]+(LIMIT * 4)); 
		candev_p->can_stats[can].error_warning=Ewarn;	
		RError= readb(baseaddr[can]+(RECNT * 4));
	        candev_p->can_stats[can].rxerr = RError;			
		TError = readb(baseaddr[can]+(TECNT * 4));			  
		candev_p->can_stats[can].txerr = TError;			 
		JNMM_PCI_RESET(baseaddr[can]);
		
	}
	if(ErrIntr & 0x40) // Error active
	{
		//printk("Error active..\n");
	        candev_p->can_stats[can].error_active=SET_VALUE;
	}
	if(ErrIntr & 0x20) // Error Passive interrupt
	{
		//printk("Error Passive interrupt 00..\n");
	        candev_p->can_stats[can].error_passive=SET_VALUE;
	}
	if(ErrIntr & 0x10) // Error stat_change
	{
		//printk("Error stat_change interrupt 00..\n");
	        candev_p->can_stats[can].stat_change=SET_VALUE;
	}				  
	if(ErrIntr & 0x08) //Error arbitration_lost enable 
	{
		//printk("Error arbitration_lost enable ..\n");
		candev_p->can_stats[can].arbitration_lost_enable=SET_VALUE;
		err_cap = readb(baseaddr[can]+(EALCAP * 4)); 
		/*set error type */
		switch(err_cap & 0xE0)
		{
                  case 0x20: //bit_error
                   candev_p->can_stats[can].bit_error = SET_VALUE;
                   break;
                   case 0x60:// stuff_error
                   candev_p->can_stats[can].stuff_error = SET_VALUE;
                   break;
		   case 0x40: //form_error
                   candev_p->can_stats[can].form_error = SET_VALUE;
                   break;
		   default:
			break;
 
                     
		}
	}
	if(ErrIntr & 0x04) //Error arbitration_lost flag 
	{
		//printk("Error arbitration_lost flag \n");
		candev_p->can_stats[can].arbitration_lost++;
	}
	if(ErrIntr & 0x02) // bus Error enable interrupt
	{
		//printk("bus Error enable interrupt ..\n");
		candev_p->can_stats[can].bus_error_enable=SET_VALUE; 
		readb(baseaddr[can]+(EALCAP * 4)); 
	}
	if(ErrIntr & 0x01) // bus Error enable flag interrupt
	{
		//printk("bus Error enable flag interrupt \n");
		candev_p->can_stats[can].bus_error++; 
		readb(baseaddr[can]+(EALCAP * 4)); 
	}
			 
}
/////////////////////////////////////////////////////////////////////////////////////////
//
//isa_err_intr
//Description:
//
// This function read the error status for  CAN device ISA for CAN(0-3) based on the CAN Port selected 
//
//Return:
// void 
///////////////////////////////////////////////////////////////////////////////////////
void isa_err_intr(can_dev *candev_p,int can,unsigned char ErrIntr)
{
	unsigned char Ewarn,RError,TError;

	if(ErrIntr & 0x80 )
	{
		Ewarn = inb(isabaseaddr[can]+(LIMIT )); 
		RError= inb(isabaseaddr[can]+(RECNT));		
		TError = inb(isabaseaddr[can]+(TECNT));			  
	}
	if(ErrIntr & 0x20) // Error Passive interrupt
	{
		printk("Error Passive interrupt 00..\n");
	}
	if(ErrIntr & 0x08)
	{
		printk("Error Passive interrupt EALCAP0..\n");
		inb(isabaseaddr[can]+(EALCAP )); 
	}
	if(ErrIntr & 0x02) // Error Passive interrupt
	{
		printk("Error Passive interrupt 01..\n");
		//JNMM_PCI_RESET(baseaddr[CAN_1]);
		//CAN_Reset_mode(baseaddr[CAN_0]);
		inb(isabaseaddr[can]+(EALCAP)); 
	}
}
/////////////////////////////////////////////////////////////////////////////////////////
//
//pci_set_baudrate
//Description:
//
// This function set the baudrate for  CAN device PCI for CAN(0-3) based on the CAN Port selected 
//
//Return:
// void 
///////////////////////////////////////////////////////////////////////////////////////
static int pci_set_baudrate(void *base_addr,int baudrate)
{
	unsigned int Tseg_1;
	unsigned int Tseg_2;
	unsigned int SJW;
	unsigned int S_PRESC;
	unsigned int BitTime_0, BitTime_1, BitTime_2;	
	
	
	pci_can_init(base_addr);


	switch (baudrate)  // setting actual bus timing
	{                           // all @ 16 Mhz
		case 8://CAN_SPEED_10K: // 37, 11, 64
			Tseg_1 = 37;
			Tseg_2 = 11;
			SJW = 1;
			S_PRESC = 64;
			break;
		case 7://CAN_SPEED_20K:
			Tseg_1 = 21;
			Tseg_2 = 3;
			SJW = 1;
			S_PRESC = 60;
			break;
		case 6://CAN_SPEED_50K:
			Tseg_1 = 17 ;
			Tseg_2 =  2;
			SJW = 1;
			S_PRESC = 29 ;
			break;
		case 5://CAN_SPEED_100K:
			Tseg_1 = 11;
			Tseg_2 = 2;
			SJW = 1;
			S_PRESC = 20;
			break;
		case 4://CAN_SPEED_125K:
			Tseg_1 = 16;
			Tseg_2 = 3;
			SJW = 1;
			S_PRESC = 11;
			break;
		case 3://CAN_SPEED_250K:
			Tseg_1 = 8;
			Tseg_2 = 1;
			SJW = 1;
			S_PRESC = 10;
			break;
		case 2://CAN_SPEED_500K:
			Tseg_1 = 18;
			Tseg_2 = 1;
			SJW = 1;
			S_PRESC = 2;
			break;
		case 1://CAN_SPEED_800K:
			Tseg_1 = 9;
			Tseg_2 = 2;
			SJW = 1;
			S_PRESC = 2;
			break;
		case 0://CAN_SPEED_1M:
			Tseg_1 = 6;
			Tseg_2 = 2;
			SJW = 1;
			S_PRESC = 2;
			break;
		default:
			return -1;
	}

	BitTime_0 = (Tseg_1 );//| (SJW << 6); 
	BitTime_1 = (Tseg_2 ) ;//| ((Tseg_2 - 1) << 5 );
	BitTime_2 = (SJW) ;//| ((Tseg_1) << 4 );


	writeb(0x80, (base_addr + (CFG_STAT * 4))) ;
	//msleep(1) ;
	writeb(BitTime_0, (base_addr + (BITTIME0 * 4))) ;
	//msleep(1) ;
	writeb(BitTime_1, (base_addr + (BITTIME1 * 4))) ;
	//msleep(1) ;
	writeb(BitTime_2, (base_addr + (BITTIME2 * 4))) ;
	//msleep(1) ;
	writeb(S_PRESC, (base_addr + (SPRESC * 4))) ;
	//writeb(S_PRESC, (base_addr + (FPRESC * 4))) ;
	//msleep(2) ;
	writeb(0x00, (base_addr + (CFG_STAT * 4))) ;
	//msleep(2) ;
	writeb(0xFF, (base_addr+(RTIE * 4))) ;
	//msleep(2) ;

	return 0;

}
/////////////////////////////////////////////////////////////////////////////////////////
//
//PCIDatareceive3
//Description:
//
// This function is called from the ISR routine based on the RIF set and read  the RX buffer  for  CAN device PCI for CAN(3) 
//
//Return:
// void 
///////////////////////////////////////////////////////////////////////////////////////
void PCIDatareceive3(int can,can_dev *candev_p)
{
	
	unsigned char i;
	unsigned int offset ;
	unsigned char rx_buf[16]; 
	unsigned char Data[16];
	unsigned char ractive=0,rx_status=0,rstat =0 ,value=0;
	void * base_addr;
	base_addr = baseaddr[can];

	do{    // Handling the message reception 
	
	offset = 0x00 ;
	for(i=0; i<5; i++ )
	{
		rx_buf[i] = readb(base_addr + ((offset+i) * 4)) ;
	}
	Data[6] = rx_buf[4] ; // dlc
	Data[0] = ((rx_buf[4]  & 0x40)==0) ?0:1 ;

	//read data
	offset = 0x00 + 0x08 ;
	if((rx_buf[4] & 0x40) == 0)
	{
		for (i=0; i< (Data[6] & (0x0F)); i++ )
		{
			Data[i+7] = readb(base_addr + ((offset+i) * 4)) ;
		}
	}
	else
	 memset(&(Data[7]),0,(Data[6] & (0x0F)));
	
	
	// Check for IDE Bit 
	if ( (rx_buf[4] & 0x80 ) == 0x80 )
	{
		Data[1] = 1 ; // message type 
		Data[2] = (rx_buf[0]);
		Data[3]  = ( rx_buf[1]);
		Data[4]  = ( rx_buf[2]);
		Data[5]  = ( rx_buf[3]);
		//DbgPrint("combined %x \n",((data[3]<<8)));
	}
	else
	{
		Data[1] = 0 ;
		Data[2] = 0;
		Data[3] = 0;
		Data[4] = (rx_buf[0]);
		Data[5] = (rx_buf[1]);
		//DbgPrint("std can_id %x\n",devExt->can_id[can]);
	}

	// Empty the RBUF which is read 
	offset =  (RCTRL)  *4;
	rx_status =  0x10 ;
	writeb(rx_status, (base_addr+offset)) ;
	
	offset = (RBUF_COUNT*4);
	ractive = readb(base_addr + offset )  ;

	offset = (RCTRL)  *4;
	value = readb(base_addr + offset )  ;
	
	rstat = value & 0x03;
	
	memcpy( candev_p->Q3[candev_p->Rear3], Data,16);
	candev_p->Rear3++;

	if(candev_p->Rear3 > MAXQ){
			candev_p->Rear3 = 0;
	}

	if(candev_p->Rear3 == candev_p->Front3) {
			candev_p->Front3++;
	}

	if(candev_p->Front3 > MAXQ){
			candev_p->Front3 = 0;
	}	
	
	}while(ractive!=0 && rstat!=0);
	
	return ;
	
}
/////////////////////////////////////////////////////////////////////////////////////////
//
//PCIDatareceive2
//Description:
//
// This function is called from the ISR routine based on the RIF set and read  the RX buffer  for  CAN device PCI for CAN(2) 
//
//Return:
// void 
///////////////////////////////////////////////////////////////////////////////////////
void PCIDatareceive2(int can,can_dev *candev_p)
{
	
	unsigned char i;
	unsigned int offset ;
	unsigned char rx_buf[16]; 
	unsigned char Data[16];
	unsigned char ractive=0,rx_status=0,value=0,rstat =0;
	void * base_addr;
	base_addr = baseaddr[can];

	do{    // Handling the message reception 
	
	offset = 0x00 ;
	for(i=0; i<5; i++ )
	{
		rx_buf[i] = readb(base_addr + ((offset+i) * 4)) ;
	}
	Data[6] = rx_buf[4] ; // dlc
	Data[0] = ((rx_buf[4]  & 0x40)==0) ?0:1 ;

	//read data
	offset = 0x00 + 0x08 ;
	if((rx_buf[4] & 0x40) == 0)
	{
		for (i=0; i< (Data[6] & (0x0F)); i++ )
		{
			Data[i+7] = readb(base_addr + ((offset+i) * 4)) ;
		}
	}
	else
	 memset(&(Data[7]),0,(Data[6] & (0x0F)));
	
	
	// Check for IDE Bit 
	if ( (rx_buf[4] & 0x80 ) == 0x80 )
	{
		Data[1] = 1 ; // message type 
		Data[2] = (rx_buf[0]);
		Data[3]  = ( rx_buf[1]);
		Data[4]  = ( rx_buf[2]);
		Data[5]  = ( rx_buf[3]);
		//DbgPrint("combined %x \n",((data[3]<<8)));
	}
	else
	{
		Data[1] = 0 ;
		Data[2] = 0;
		Data[3] = 0;
		Data[4] = (rx_buf[0]);
		Data[5] = (rx_buf[1]);
		//DbgPrint("std can_id %x\n",devExt->can_id[can]);
	}

	// Empty the RBUF which is read 
	offset =  (RCTRL)  *4;
	rx_status =  0x10 ;
	writeb(rx_status, (base_addr+offset)) ;
	
	offset = (RBUF_COUNT*4);
	ractive = readb(base_addr + offset )  ;

	offset = (RCTRL)  *4;
	value = readb(base_addr + offset )  ;
	
	rstat = value & 0x03;
	
	memcpy( candev_p->Q2[candev_p->Rear2], Data,16);
	candev_p->Rear2++;

	if(candev_p->Rear2 > MAXQ){
			candev_p->Rear2 = 0;
	}

	if(candev_p->Rear2 == candev_p->Front2) {
			candev_p->Front2++;
	}

	if(candev_p->Front2 > MAXQ){
			candev_p->Front2 = 0;
	}	
	
	}while(ractive!=0 && rstat!=0);
	
	return ;
	
}
/////////////////////////////////////////////////////////////////////////////////////////
//
//PCIDatareceive1
//Description:
//
// This function is called from the ISR routine based on the RIF set and read  the RX buffer  for  CAN device PCI for CAN(1) 
//
//Return:
// void 
///////////////////////////////////////////////////////////////////////////////////////
void PCIDatareceive1(int can,can_dev *candev_p)
{
	
	unsigned char i;
	unsigned int offset ;
	unsigned char rx_buf[16]; 
	unsigned char Data[16];
	unsigned char ractive=0,rx_status=0,value=0,rstat =0;
	void * base_addr;
	base_addr = baseaddr[can];

	do{    // Handling the message reception 
	
	offset = 0x00 ;
	for(i=0; i<5; i++ )
	{
		rx_buf[i] = readb(base_addr + ((offset+i) * 4)) ;
	}
	Data[6] = rx_buf[4] ; // dlc
	Data[0] = ((rx_buf[4]  & 0x40)==0) ?0:1 ;

	//read data
	offset = 0x00 + 0x08 ;
	if((rx_buf[4] & 0x40) == 0)
	{
		for (i=0; i< (Data[6] & (0x0F)); i++ )
		{
			Data[i+7] = readb(base_addr + ((offset+i) * 4)) ;
		}
	}
	else
	 memset(&(Data[7]),0,(Data[6] & (0x0F)));
	
	
	// Check for IDE Bit 
	if ( (rx_buf[4] & 0x80 ) == 0x80 )
	{
		Data[1] = 1 ; // message type 
		Data[2] = (rx_buf[0]);
		Data[3]  = ( rx_buf[1]);
		Data[4]  = ( rx_buf[2]);
		Data[5]  = ( rx_buf[3]);
		//DbgPrint("combined %x \n",((data[3]<<8)));
	}
	else
	{
		Data[1] = 0 ;
		Data[2] = 0;
		Data[3] = 0;
		Data[4] = (rx_buf[0]);
		Data[5] = (rx_buf[1]);
		//DbgPrint("std can_id %x\n",devExt->can_id[can]);
	}

	// Empty the RBUF which is read 
	offset =  (RCTRL)  *4;
	rx_status =  0x10 ;
	writeb(rx_status, (base_addr+offset)) ;
	
	offset = (RBUF_COUNT*4);
	ractive = readb(base_addr + offset )  ;
	
	offset = (RCTRL)  *4;
	value = readb(base_addr + offset )  ;
	
	rstat = value & 0x03;	

	memcpy( candev_p->Q1[candev_p->Rear1], Data,16);
	candev_p->Rear1++;

	if(candev_p->Rear1 > MAXQ){
			candev_p->Rear1 = 0;
	}

	if(candev_p->Rear1 == candev_p->Front1) {
			candev_p->Front1++;
	}

	if(candev_p->Front1 > MAXQ){
			candev_p->Front1 = 0;
	}	
	
	}while(ractive!=0 && rstat!=0);
	
	return ;
	
}
/////////////////////////////////////////////////////////////////////////////////////////
//
//PCIDatareceive1
//Description:
//
// This function is called from the ISR routine based on the RIF set and read  the RX buffer  for  CAN device PCI for CAN(0) 
//
//Return:
// void 
///////////////////////////////////////////////////////////////////////////////////////
void PCIDatareceive0(int can,can_dev *candev_p)
{
	
	unsigned char i;
	unsigned int offset ;
	unsigned char rx_buf[16]; 
	unsigned char Data[16];
	unsigned char ractive=0,rx_status=0,value=0,rstat =0;
	void * base_addr;
	base_addr = baseaddr[can];

	do{    // Handling the message reception 
	
	offset = 0x00 ;
	for(i=0; i<5; i++ )
	{
		rx_buf[i] = readb(base_addr + ((offset+i) * 4)) ;
	}
	Data[6] = rx_buf[4] ; // dlc
	Data[0] = ((rx_buf[4]  & 0x40)==0) ?0:1 ;

	//read data
	offset = 0x00 + 0x08 ;
	if((rx_buf[4] & 0x40) == 0)
	{
		for (i=0; i< (Data[6] & (0x0F)); i++ )
		{
			Data[i+7] = readb(base_addr + ((offset+i) * 4)) ;
		}
	}
	else
	 memset(&(Data[7]),0,(Data[6] & (0x0F)));
	
	
	// Check for IDE Bit 
	if ( (rx_buf[4] & 0x80 ) == 0x80 )
	{
		Data[1] = 1 ; // message type 
		Data[2] = (rx_buf[0]);
		Data[3]  = ( rx_buf[1]);
		Data[4]  = ( rx_buf[2]);
		Data[5]  = ( rx_buf[3]);
		//DbgPrint("combined %x \n",((data[3]<<8)));
	}
	else
	{
		Data[1] = 0 ;
		Data[2] = 0;
		Data[3] = 0;
		Data[4] = (rx_buf[0]);
		Data[5] = (rx_buf[1]);
		//DbgPrint("std can_id %x\n",devExt->can_id[can]);
	}

	// Empty the RBUF which is read 
	offset =  (RCTRL)  *4;
	rx_status =  0x10 ;
	writeb(rx_status, (base_addr+offset)) ;
	
	offset = (RBUF_COUNT*4);
	ractive = readb(base_addr + offset )  ;

	offset = (RCTRL)  *4;
	value = readb(base_addr + offset )  ;
	
	rstat = value & 0x03;
	memcpy( candev_p->Q0[candev_p->Rear0], Data,16);
	candev_p->Rear0++;

	if(candev_p->Rear0 > MAXQ){
			candev_p->Rear0 = 0;
	}

	if(candev_p->Rear0 == candev_p->Front0) {
			candev_p->Front0++;
	}

	if(candev_p->Front0 > MAXQ){
			candev_p->Front0 = 0;
	}	
	
	}while(ractive!=0 && rstat !=0);
	
	return ;
	
}
/////////////////////////////////////////////////////////////////////////////////////////
//
//JNMM_PCI_Handler
//Description:
//
// This function is  the ISR routine based on the interrupt  set   for  CAN device PCI for CAN(0-3) 
//
//Return:
// return IRQ_NONE or  IRQ_HANDLED
///////////////////////////////////////////////////////////////////////////////////////
static irqreturn_t JNMM_PCI_Handler(int irq, void *dev_id)/*,struct pt_regs *regs)*/
{
	
	unsigned char value0,dio,value1,value2,value3;
	unsigned char Boff,ErrIntr,Rel_buf;
	can_dev *candev_p;
	
	int can =CAN_INVALID;
	candev_p = (can_dev*)dev_id ;
	// Read the INTR status for CAN(0-3) Device
	dio = readb(dio_base_addr +(DIO_INTR*4));

	if(dio)
	{
		if((dio >> 0) & 1)
		{
			value0 = readb(baseaddr[CAN_0] +( RTIF*4)) ;
			if(value0 & RIF_STAT)
			{
			   can = CAN_0;
			   PCIDatareceive0(can,candev_p);
			   candev_p->can_stats[can].rxpackets++;	
			   
			}
			else if(value0 & (ROIF_STAT | RFIF_STAT | RAFIF_STAT))
			{
			  // Empty the RBUF which is read 
			  Rel_buf =  0x10 ;
			  can = CAN_0;
			  writeb(Rel_buf, (baseaddr[CAN_0]+((RCTRL)  *4))) ;
			  candev_p->can_stats[can].rx_over_errors++;		
			}
			else if(value0 & TPIF_STAT)
			{
			  can = CAN_0;
			  Wake_up_fake_Cond_0  = 1 ;
			  wake_up(&candev_p->write_queue0); 
			  candev_p->can_stats[can].txpackets++;	
			 	
			}
			else if(value0 & TSIF_STAT)
			{
			  can = CAN_0;
			  Wake_up_fake_Cond_0  = 1 ;
			  wake_up(&candev_p->write_queue0);  // Wakes up write()
		      candev_p->can_stats[can].txpackets++;	
			 
			}
			else if(value0 & EIF_STAT)
			{
	           can = CAN_0;
			  Boff = readb(baseaddr[can]+(CFG_STAT * 4));
			  candev_p->can_stats[can].bus_off= Boff;	
			  ErrIntr = readb(baseaddr[can]+(ERRINT * 4));
			  pci_err_intr(candev_p,can,ErrIntr); 			
			}
			else if(value0 & AIF_STAT)
			{
			   
			}
			writeb(0x1, (dio_base_addr +(DIO_INTR*4)));			
		}
		
		if((dio >> 1) & 1)
		{
			value1 = readb(baseaddr[CAN_1] +( RTIF*4)) ;
			if(value1 & RIF_STAT)
			{
			   can = CAN_1;
			   PCIDatareceive1(can,candev_p);
			   candev_p->can_stats[can].rxpackets++;	
			   
			}
			else if(value1 & (ROIF_STAT | RFIF_STAT | RAFIF_STAT))
			{
			  // Empty the RBUF which is read 
			  Rel_buf =  0x10 ;
			  can = CAN_1;
			  writeb(Rel_buf, (baseaddr[CAN_1]+((RCTRL)  *4))) ;
			  candev_p->can_stats[can].rx_over_errors++;		
			}
			else if(value1 & TPIF_STAT)
			{
			  can = CAN_1;
			  Wake_up_fake_Cond_1  = 1 ;
			  wake_up(&candev_p->write_queue1); 
			  candev_p->can_stats[can].txpackets++;	
			 	
			}
			else if(value1 & TSIF_STAT)
			{
			  can = CAN_1;
			  Wake_up_fake_Cond_1  = 1 ;
			  wake_up(&candev_p->write_queue1);  // Wakes up write()
		      candev_p->can_stats[can].txpackets++;	
			 
			}
			else if(value1 & EIF_STAT)
			{
	           can = CAN_1;
			  Boff = readb(baseaddr[can]+(CFG_STAT * 4));
			  candev_p->can_stats[can].bus_off= Boff;	
			  ErrIntr = readb(baseaddr[can]+(ERRINT * 4));
			  pci_err_intr(candev_p,can,ErrIntr); 			
			}
			else if(value1 & AIF_STAT)
			{
			   
			}
			writeb(0x2, (dio_base_addr +(DIO_INTR*4)));			
		}
		
		if((dio >> 2) & 1)
		{
			value2 = readb(baseaddr[CAN_2] +( RTIF*4)) ;
			if(value2 & RIF_STAT)
			{
			   can = CAN_2;
			   PCIDatareceive2(can,candev_p);
			   candev_p->can_stats[can].rxpackets++;	
			   
			}
			else if(value2 & (ROIF_STAT | RFIF_STAT | RAFIF_STAT))
			{
			  // Empty the RBUF which is read 
			  Rel_buf =  0x10 ;
			  can = CAN_2;
			  writeb(Rel_buf, (baseaddr[CAN_2]+((RCTRL)  *4))) ;
			  candev_p->can_stats[can].rx_over_errors++;		
			}
			else if(value2 & TPIF_STAT)
			{
			  can = CAN_2;
			  Wake_up_fake_Cond_2  = 1 ;
			  wake_up(&candev_p->write_queue2); 
			  candev_p->can_stats[can].txpackets++;	
			 	
			}
			else if(value2 & TSIF_STAT)
			{
			  can = CAN_2;
			  Wake_up_fake_Cond_2  = 1 ;
			  wake_up(&candev_p->write_queue2);  // Wakes up write()
		      candev_p->can_stats[can].txpackets++;	
			 
			}
			else if(value2 & EIF_STAT)
			{
	           can = CAN_2;
			  Boff = readb(baseaddr[can]+(CFG_STAT * 4));
			  candev_p->can_stats[can].bus_off= Boff;	
			  ErrIntr = readb(baseaddr[can]+(ERRINT * 4));
			  pci_err_intr(candev_p,can,ErrIntr); 			
			}
			else if(value2 & AIF_STAT)
			{
			   
			}
			writeb(0x4, (dio_base_addr +(DIO_INTR*4)));			
		}
		
			
		if((dio >> 3) & 1)
		{
			value3 = readb(baseaddr[CAN_3] +( RTIF*4)) ;
			if(value3 & RIF_STAT)
			{
			   can = CAN_3;
			   PCIDatareceive3(can,candev_p);
			   candev_p->can_stats[can].rxpackets++;	
			   
			}
			else if(value3 & (ROIF_STAT | RFIF_STAT | RAFIF_STAT))
			{
			  // Empty the RBUF which is read 
			  Rel_buf =  0x10 ;
			  can = CAN_3;
			  writeb(Rel_buf, (baseaddr[CAN_3]+((RCTRL)  *4))) ;
			  candev_p->can_stats[can].rx_over_errors++;		
			}
			else if(value3 & TPIF_STAT)
			{
			  can = CAN_3;
			  Wake_up_fake_Cond_3  = 1 ;
			  wake_up(&candev_p->write_queue3); 
			  candev_p->can_stats[can].txpackets++;	
			 	
			}
			else if(value3 & TSIF_STAT)
			{
			  can = CAN_3;
			  Wake_up_fake_Cond_3  = 1 ;
			  wake_up(&candev_p->write_queue3);  // Wakes up write()
		      candev_p->can_stats[can].txpackets++;	
			 
			}
			else if(value3 & EIF_STAT)
			{
	          can = CAN_3;
			  Boff = readb(baseaddr[can]+(CFG_STAT * 4));
			  candev_p->can_stats[can].bus_off= Boff;	
			  ErrIntr = readb(baseaddr[can]+(ERRINT * 4));
			  pci_err_intr(candev_p,can,ErrIntr); 			
			}
			else if(value3 & AIF_STAT)
			{
			   
			}
			writeb(0x8, (dio_base_addr +(DIO_INTR*4)));			
		}
		return IRQ_HANDLED;
	}
	else
	return IRQ_NONE;
}		   
/////////////////////////////////////////////////////////////////////////////////////////
//
//JNMM_PCI_Handler
//Description:
//
// This function is  the ISR routine based on the interrupt  set   for  CAN device ISA for CAN(0-3) 
//
//Return:
// return IRQ_NONE or  IRQ_HANDLED
///////////////////////////////////////////////////////////////////////////////////////
static irqreturn_t JNMM_ISA_Handler(int irq, void *dev_id)
{
	
	unsigned char Boff,ErrIntr,Rel_buf;	
	unsigned char value0,dio,value1,value2,value3;
	can_dev *candev_p;
	int can =CAN_INVALID;
	candev_p = (can_dev*)dev_id ;
	
	// Read the INTR status for CAN(0-3) Device
	//printk("JNMM_ISA_Handler isa_dio_base_addr %x\n ",isa_dio_base_addr);
	dio = inb(isa_dio_base_addr +(DIO_INTR));
		
	if(dio)
	{
		if((dio >> 0) & 1)
		{
			value0 = inb(isabaseaddr[CAN_0] +( RTIF)) ;
			if(value0 & RIF_STAT)
			{
			   can = CAN_0;
			   Datareceive0(can,candev_p);
			   candev_p->can_stats[can].rxpackets++;	
		           //  printk("Datareceive0 ..\n"); 
			}
			else if(value0 & (ROIF_STAT | RFIF_STAT | RAFIF_STAT))
			{
			  // Empty the RBUF which is read 
			  Rel_buf =  0x10 ;
			  outb(Rel_buf, (isabaseaddr[CAN_0]+((RCTRL)))) ;
			  printk("ROIF_STAT Interrupt0 ..\n");
			  candev_p->can_stats[CAN_0].rx_over_errors++;
			}
			else if(value0 & TPIF_STAT)
			{
			 // printk("TPIF Interrupt0 ..\n");
			  flag =0;
			  Wake_up_fake_Cond_0  = 1 ;
			  wake_up(&candev_p->write_queue0); 
			  candev_p->can_stats[CAN_0].txpackets++;	
			}
			else if(value0 & TSIF_STAT)
			{
			  Wake_up_fake_Cond_0  = 1 ;
			  wake_up(&candev_p->write_queue0);  // Wakes up read()			 
			 candev_p->can_stats[CAN_0].txpackets++;	
			//  printk("TSIF Interrupt0 ..\n");
			}
			else if(value0 & EIF_STAT)
			{
			  can = CAN_0;
			  Boff = inb(isabaseaddr[can]+(CFG_STAT));
			  
			  ErrIntr = inb(isabaseaddr[can]+(ERRINT)); 
			  isa_err_intr(candev_p,can,ErrIntr);
			}
			if(value0 & AIF_STAT)
			{
			   
			}
			outb(0x01, (isa_dio_base_addr +(DIO_INTR)));	
		}
		
		if((dio >> 1) & 1)
		{
			value1 = inb(isabaseaddr[CAN_1] +( RTIF)) ;
			if(value1 & RIF_STAT)
			{
			   can = CAN_1;
			   Datareceive1(can,candev_p);
			   candev_p->can_stats[can].rxpackets++;	
		           //  printk("Datareceive0 ..\n"); 
			}
			else if(value1 & (ROIF_STAT | RFIF_STAT | RAFIF_STAT))
			{
			  // Empty the RBUF which is read 
			  Rel_buf =  0x10 ;
			  outb(Rel_buf, (isabaseaddr[CAN_1]+((RCTRL)))) ;
			  printk("ROIF_STAT Interrupt0 ..\n");
			  candev_p->can_stats[CAN_1].rx_over_errors++;
			}
			else if(value1 & TPIF_STAT)
			{
			 // printk("TPIF Interrupt0 ..\n");
			  flag =0;
			  Wake_up_fake_Cond_1  = 1 ;
			  wake_up(&candev_p->write_queue1); 
			  candev_p->can_stats[CAN_1].txpackets++;	
			}
			else if(value1 & TSIF_STAT)
			{
			  Wake_up_fake_Cond_1  = 1 ;
			  wake_up(&candev_p->write_queue1);  // Wakes up read()			 
			 candev_p->can_stats[CAN_1].txpackets++;	
			//  printk("TSIF Interrupt0 ..\n");
			}
			else if(value1 & EIF_STAT)
			{
			  can = CAN_1;
			  Boff = inb(isabaseaddr[can]+(CFG_STAT));
			  
			  ErrIntr = inb(isabaseaddr[can]+(ERRINT)); 
			  isa_err_intr(candev_p,can,ErrIntr);
			}
			if(value1 & AIF_STAT)
			{
			   
			}
			outb(0x02, (isa_dio_base_addr +(DIO_INTR)));
		}
		
		if((dio >> 2) & 1)
		{
			value2 = inb(isabaseaddr[CAN_2] +( RTIF)) ;
			if(value2 & RIF_STAT)
			{
			   can = CAN_2;
			   Datareceive2(can,candev_p);
			   candev_p->can_stats[can].rxpackets++;	
		           //  printk("Datareceive0 ..\n"); 
			}
			else if(value2 & (ROIF_STAT | RFIF_STAT | RAFIF_STAT))
			{
			  // Empty the RBUF which is read 
			  Rel_buf =  0x10 ;
			  outb(Rel_buf, (isabaseaddr[CAN_2]+((RCTRL)))) ;
			  printk("ROIF_STAT Interrupt0 ..\n");
			  candev_p->can_stats[CAN_2].rx_over_errors++;
			}
			else if(value2 & TPIF_STAT)
			{
			 // printk("TPIF Interrupt0 ..\n");
			  flag =0;
			  Wake_up_fake_Cond_2  = 1 ;
			  wake_up(&candev_p->write_queue2); 
			  candev_p->can_stats[CAN_2].txpackets++;	
			}
			else if(value2 & TSIF_STAT)
			{
			  Wake_up_fake_Cond_2  = 1 ;
			  wake_up(&candev_p->write_queue2);  // Wakes up read()			 
			 candev_p->can_stats[CAN_2].txpackets++;	
			//  printk("TSIF Interrupt0 ..\n");
			}
			else if(value2 & EIF_STAT)
			{
			  can = CAN_2;
			  Boff = inb(isabaseaddr[can]+(CFG_STAT));
			  
			  ErrIntr = inb(isabaseaddr[can]+(ERRINT)); 
			  isa_err_intr(candev_p,can,ErrIntr);
			}
			if(value2 & AIF_STAT)
			{
			   
			}
			outb(0x04, (isa_dio_base_addr +(DIO_INTR)));
		}
		
		if((dio >> 3) & 1)
		{
			value3 = inb(isabaseaddr[CAN_3] +( RTIF)) ;
			if(value3 & RIF_STAT)
			{
			   can = CAN_3;
			   Datareceive3(can,candev_p);
			   candev_p->can_stats[can].rxpackets++;	
		           //  printk("Datareceive0 ..\n"); 
			}
			else if(value3 & (ROIF_STAT | RFIF_STAT | RAFIF_STAT))
			{
			  // Empty the RBUF which is read 
			  Rel_buf =  0x10 ;
			  outb(Rel_buf, (isabaseaddr[CAN_3]+((RCTRL)))) ;
			  printk("ROIF_STAT Interrupt0 ..\n");
			  candev_p->can_stats[CAN_3].rx_over_errors++;
			}
			else if(value3 & TPIF_STAT)
			{
			 // printk("TPIF Interrupt0 ..\n");
			  flag =0;
			  Wake_up_fake_Cond_3  = 1 ;
			  wake_up(&candev_p->write_queue3); 
			  candev_p->can_stats[CAN_3].txpackets++;	
			}
			else if(value3 & TSIF_STAT)
			{
			  Wake_up_fake_Cond_3  = 1 ;
			  wake_up(&candev_p->write_queue3);  // Wakes up read()			 
			 candev_p->can_stats[CAN_3].txpackets++;	
			//  printk("TSIF Interrupt0 ..\n");
			}
			else if(value3 & EIF_STAT)
			{
			  can = CAN_3;
			  Boff = inb(isabaseaddr[can]+(CFG_STAT));
			  
			  ErrIntr = inb(isabaseaddr[can]+(ERRINT)); 
			  isa_err_intr(candev_p,can,ErrIntr);
			}
			if(value3 & AIF_STAT)
			{
			   
			}
			outb(0x08, (isa_dio_base_addr +(DIO_INTR)));
		}
		return IRQ_HANDLED;
	}
	else
	return IRQ_NONE;
}		   
/////////////////////////////////////////////////////////////////////////////////////////
//
//pci_dev_open
//Description:
//
// This function is  the Open handle routine for  CAN device ISA/PCI for CAN(0-3) when the driver has been installed it or PCI/ISA mode 
// and should be installed 
// will success on zero or EINVAL
// 
//Return:
// return EINVAL or  0
///////////////////////////////////////////////////////////////////////////////////////
static int pci_dev_open(struct inode* inode, struct file* file)
{
	int minor ;
	void *base_addr;
	
	struct task_struct *t ;

	t = get_current() ;
	minor = MINOR(inode->i_rdev);
	if (minor > MAX_DEV_SUPPORT )
	{
		printk(KERN_INFO "%s: Driver supports max %d CAN\n", DRV_NAME, MAX_DEV_SUPPORT);
		return -EINVAL ;
	}
	file->private_data = &candev;
	base_addr = candev.base_addr ;
	
	printk("mode %x\n",mode);

	candev.device_cnt++ ;
	printk(KERN_INFO "DSC-CAN: Device open successful. Minor=%d\n",minor);
	return 0;
}
/////////////////////////////////////////////////////////////////////////////////////////
//
//pci_dev_close
//Description:
//
// This function is  the Close handle routine for  CAN device ISA/PCI for CAN(0-3) when the driver has been installed it for PCI/ISA mode 
// and should be installed 
// will success on zero or EINVAL
// 
//Return:
// return EINVAL or  0
///////////////////////////////////////////////////////////////////////////////////////
static int pci_dev_close(struct inode* inode, struct file* file)
{
	
	int minor ;

	minor = MINOR(inode->i_rdev);

	candev.device_cnt-- ;
	printk(KERN_INFO "%s: Device Closed successful. Minor=%d\n",DRV_NAME,minor);
	
	
	return 0;
}
/////////////////////////////////////////////////////////////////////////////////////////
//
//Datareceive3
//Description:
//
// This function is called from the ISR routine based on the RIF set and read  the RX buffer  for  CAN device ISA for CAN(3) 
//
//Return:
// void 
///////////////////////////////////////////////////////////////////////////////////////
void Datareceive3(int can,can_dev *candev_p)
{
	unsigned char i;
	unsigned int offset ;
	unsigned char rx_buf[16]; 
	unsigned char Data[16];
	unsigned char ractive=0,rx_status=0,value=0,rstat =0;
	unsigned int base_addr;
	base_addr = isabaseaddr[can];

	do{    // Handling the message reception 
	offset = 0x00 ;
	for(i=0; i<5; i++ )
	{
		rx_buf[i] = inb(base_addr + ((offset+i))) ;
	}
	Data[6] = rx_buf[4] ; // dlc
	Data[0] = ((rx_buf[4]  & 0x40)==0) ?0:1 ;
	//read data
	offset = 0x00 + 0x08 ;
	if((rx_buf[4] & 0x40) == 0)
	{
		for (i=0; i< (Data[6] & (0x0F)); i++ )
		{
			Data[i+7] = inb(base_addr + (offset+i)) ;
		}
	}
	else
	{
	 	memset(&(Data[7]),0,(Data[6] & (0x0F)));
	}
	
	// Check for IDE Bit 
	if ( (rx_buf[4] & 0x80 ) == 0x80 )
	{
		Data[1] = 1 ; // message type 
		Data[2] = (rx_buf[0]);
		Data[3]  = ( rx_buf[1]);
		Data[4]  = ( rx_buf[2]);
		Data[5]  = ( rx_buf[3]);
		//DbgPrint("combined %x \n",((data[3]<<8)));
	}
	else
	{
		Data[1] = 0 ;
		Data[2] = 0;
		Data[3] = 0;
		Data[4] = (rx_buf[0]);
		Data[5] = (rx_buf[1]);
		//DbgPrint("std can_id %x\n",devExt->can_id[can]);
	}
	


	// Empty the RBUF which is read 
	offset =  (RCTRL)  ;
	rx_status =  0x10 ;
	outb(rx_status, (base_addr+offset)) ;
	
	offset = (0xAA);
	ractive = inb(base_addr + offset )  ;

	offset =  (RCTRL)  ;
	value = inb(base_addr + offset )  ;
	rstat = value & 0x03;
	
	memcpy( candev_p->Q3[candev_p->Rear3], Data,16);
	candev_p->Rear3++;

	if(candev_p->Rear3 > MAXQ){
			candev_p->Rear3 = 0;
	}

	if(candev_p->Rear3 == candev_p->Front3) {
			candev_p->Front3++;
	}

	if(candev_p->Front3 > MAXQ){
			candev_p->Front3 = 0;
	}	
	
	}while(ractive!=0 && rstat !=0);
	
	return ;
	
}
/////////////////////////////////////////////////////////////////////////////////////////
//
//Datareceive2
//Description:
//
// This function is called from the ISR routine based on the RIF set and read  the RX buffer  for  CAN device ISA for CAN(2) 
//
//Return:
// void 
///////////////////////////////////////////////////////////////////////////////////////
void Datareceive2(int can,can_dev *candev_p)
{
	unsigned char i;
	unsigned int offset ;
	unsigned char rx_buf[16]; 
	unsigned char Data[16];
	unsigned char ractive=0,rx_status=0,value=0,rstat=0;
	unsigned int base_addr;
	base_addr = isabaseaddr[can];

	do{    // Handling the message reception 
	offset = 0x00 ;
	for(i=0; i<5; i++ )
	{
		rx_buf[i] = inb(base_addr + ((offset+i))) ;
	}
	Data[6] = rx_buf[4] ; // dlc
	Data[0] = ((rx_buf[4]  & 0x40)==0) ?0:1 ;
	//read data
	offset = 0x00 + 0x08 ;
	if((rx_buf[4] & 0x40) == 0)
	{
		for (i=0; i< (Data[6] & (0x0F)); i++ )
		{
			Data[i+7] = inb(base_addr + (offset+i)) ;
		}
	}
	else
	{
	 	memset(&(Data[7]),0,(Data[6] & (0x0F)));
	}
	
	// Check for IDE Bit 
	if ( (rx_buf[4] & 0x80 ) == 0x80 )
	{
		Data[1] = 1 ; // message type 
		Data[2] = (rx_buf[0]);
		Data[3]  = ( rx_buf[1]);
		Data[4]  = ( rx_buf[2]);
		Data[5]  = ( rx_buf[3]);
		//DbgPrint("combined %x \n",((data[3]<<8)));
	}
	else
	{
		Data[1] = 0 ;
		Data[2] = 0;
		Data[3] = 0;
		Data[4] = (rx_buf[0]);
		Data[5] = (rx_buf[1]);
		//DbgPrint("std can_id %x\n",devExt->can_id[can]);
	}
	


	// Empty the RBUF which is read 
	offset =  (RCTRL)  ;
	rx_status =  0x10 ;
	outb(rx_status, (base_addr+offset)) ;
	
	offset = (0xAA);
	ractive = inb(base_addr + offset )  ;

	offset =  (RCTRL)  ;
	value = inb(base_addr + offset )  ;
	rstat = value & 0x03;
	
	memcpy( candev_p->Q2[candev_p->Rear2], Data,16);
	candev_p->Rear2++;

	if(candev_p->Rear2 > MAXQ){
			candev_p->Rear2 = 0;
	}

	if(candev_p->Rear2 == candev_p->Front2) {
			candev_p->Front2++;
	}

	if(candev_p->Front2 > MAXQ){
			candev_p->Front2 = 0;
	}	
	
	}while(ractive!=0 && rstat !=0 );
	
	return ;
	
}
/////////////////////////////////////////////////////////////////////////////////////////
//
//Datareceive1
//Description:
//
// This function is called from the ISR routine based on the RIF set and read  the RX buffer  for  CAN device ISA for CAN(1) 
//
//Return:
// void 
///////////////////////////////////////////////////////////////////////////////////////
void Datareceive1(int can,can_dev *candev_p)
{
	unsigned char i;
	unsigned int offset ;
	unsigned char rx_buf[16]; 
	unsigned char Data[16];
	
	unsigned char ractive=0,rx_status=0,value=0,rstat=0;
	unsigned int base_addr;
	base_addr = isabaseaddr[can];

	do{    // Handling the message reception 
	offset = 0x00 ;
	for(i=0; i<5; i++ )
	{
		rx_buf[i] = inb(base_addr + ((offset+i))) ;
	}
	Data[6] = rx_buf[4] ; // dlc
	Data[0] = ((rx_buf[4]  & 0x40)==0) ?0:1 ;
	//read data
	offset = 0x00 + 0x08 ;
	if((rx_buf[4] & 0x40) == 0)
	{
		for (i=0; i< (Data[6] & (0x0F)); i++ )
		{
			Data[i+7] = inb(base_addr + (offset+i)) ;
		}
	}
	else
	{
	 	memset(&(Data[7]),0,(Data[6] & (0x0F)));
	}
	
	// Check for IDE Bit 
	if ( (rx_buf[4] & 0x80 ) == 0x80 )
	{
		Data[1] = 1 ; // message type 
		Data[2] = (rx_buf[0]);
		Data[3]  = ( rx_buf[1]);
		Data[4]  = ( rx_buf[2]);
		Data[5]  = ( rx_buf[3]);
		//DbgPrint("combined %x \n",((data[3]<<8)));
	}
	else
	{
		Data[1] = 0 ;
		Data[2] = 0;
		Data[3] = 0;
		Data[4] = (rx_buf[0]);
		Data[5] = (rx_buf[1]);
		//DbgPrint("std can_id %x\n",devExt->can_id[can]);
	}
	
	// Empty the RBUF which is read 
	offset =  (RCTRL)  ;
	rx_status =  0x10 ;
	outb(rx_status, (base_addr+offset)) ;
	
	offset = (0xAA);
	ractive = inb(base_addr + offset )  ;
	
	offset =  (RCTRL)  ;
	value = inb(base_addr + offset )  ;
	rstat = value & 0x03;

	memcpy( candev_p->Q1[candev_p->Rear1], Data,16);
	candev_p->Rear1++;

	if(candev_p->Rear1 > MAXQ){
			candev_p->Rear1 = 0;
	}

	if(candev_p->Rear1 == candev_p->Front1) {
			candev_p->Front1++;
	}

	if(candev_p->Front1 > MAXQ){
			candev_p->Front1 = 0;
	}	
	
	}while(ractive!=0 && rstat !=0);
	
	return ;
	
}
/////////////////////////////////////////////////////////////////////////////////////////
//
//Datareceive0
//Description:
//
// This function is called from the ISR routine based on the RIF set and read  the RX buffer  for  CAN device ISA for CAN(0) 
//
//Return:
// void 
///////////////////////////////////////////////////////////////////////////////////////
void Datareceive0(int can,can_dev *candev_p)
{
	unsigned char i;
	unsigned int offset ;
	unsigned char rx_buf[16]; 
	unsigned char Data[16];
	unsigned char ractive=0,rx_status=0,value=0,rstat =0;
	unsigned int base_addr;
	base_addr = isabaseaddr[can];

	do{    // Handling the message reception 
	offset = 0x00 ;
	for(i=0; i<5; i++ )
	{
		rx_buf[i] = inb(base_addr + ((offset+i))) ;
	}
	Data[6] = rx_buf[4] ; // dlc
	Data[0] = ((rx_buf[4]  & 0x40)==0) ?0:1 ;
	//read data
	offset = 0x00 + 0x08 ;
	if((rx_buf[4] & 0x40) == 0)
	{
		for (i=0; i< (Data[6] & (0x0F)); i++ )
		{
			Data[i+7] = inb(base_addr + (offset+i)) ;
		}
	}
	else
	{
	 	memset(&(Data[7]),0,(Data[6] & (0x0F)));
	}
	
	// Check for IDE Bit 
	if ( (rx_buf[4] & 0x80 ) == 0x80 )
	{
		Data[1] = 1 ; // message type 
		Data[2] = (rx_buf[0]);
		Data[3]  = ( rx_buf[1]);
		Data[4]  = ( rx_buf[2]);
		Data[5]  = ( rx_buf[3]);
		//DbgPrint("combined %x \n",((data[3]<<8)));
	}
	else
	{
		Data[1] = 0 ;
		Data[2] = 0;
		Data[3] = 0;
		Data[4] = (rx_buf[0]);
		Data[5] = (rx_buf[1]);
		//DbgPrint("std can_id %x\n",devExt->can_id[can]);
	}
	


	// Empty the RBUF which is read 
	offset =  (RCTRL)  ;
	rx_status =  0x10 ;
	outb(rx_status, (base_addr+offset)) ;
	
	offset = (0xAA);
	ractive = inb(base_addr + offset )  ;

	offset =  (RCTRL)  ;
	value = inb(base_addr + offset )  ;
	rstat = value & 0x03;
	
	memcpy( candev_p->Q0[candev_p->Rear0], Data,16);
	candev_p->Rear0++;

	if(candev_p->Rear0 > MAXQ){
			candev_p->Rear0 = 0;
	}

	if(candev_p->Rear0 == candev_p->Front0) {
			candev_p->Front0++;
	}

	if(candev_p->Front0 > MAXQ){
			candev_p->Front0 = 0;
	}	
	
	}while(ractive!=0 && rstat !=0);
	
	return ;
	
}
/////////////////////////////////////////////////////////////////////////////////////////
//
//isa_dev_tx_stb_frame
//Description:
//
// This function is called from the pci_dev_write system call where the user selected for STB buffer type   for  CAN device ISA for CAN(0-3) based on 
// the port selected 
//
//Return:
// void 
///////////////////////////////////////////////////////////////////////////////////////
void isa_dev_tx_stb_frame(PCANMESSAGE pTXCANMessage)
{
	int j;
	unsigned int value ,dlc ;
	unsigned int offset;
	unsigned int isa_base_addr;
	unsigned char MsgType, tmp;
	
	isa_base_addr = isabaseaddr[pTXCANMessage->Can_ch];
	offset = TCMD ;
	value = 0x80; // PTB 0x00 STB= 0x80
	outb(value, (isa_base_addr+offset)) ;


	MsgType = pTXCANMessage->Msg_type ;
	

	if ( MsgType == 0 ) // Standard CAN Message 
	{
		value = pTXCANMessage->Msg_ID ;
		offset = (TBUF + MSG_ID_1 );
		outb(((value & 0x7F8) >> 3), (isa_base_addr+offset)) ;

		offset = (TBUF + MSG_ID_2 );
		value = ((value & 0x07) << 0x05);
		outb(value, (isa_base_addr+offset)) ;
	}	
	else  // Else it is extended Message 
	{
		value = pTXCANMessage->Msg_ID ;
		
		offset = (TBUF + MSG_ID_1 );
		tmp = (value >> 21 ) ;
		outb(tmp, (isa_base_addr+offset)) ;

		offset = (TBUF + MSG_ID_2 );
		tmp = (value >> 13 ) & 0xff ;
		outb(tmp, (isa_base_addr+offset)) ;

		offset = (TBUF + MSG_ID_3 );
		tmp = (value >> 5 ) & 0xff ;
		outb(tmp, (isa_base_addr+offset)) ;

		offset = (TBUF + MSG_ID_4 );
			tmp = (value & 0x1f) ;
			tmp = (tmp<<3) ;
			outb(tmp, (isa_base_addr+offset)) ;
		}
	

		offset = (TBUF+TBUF_CTRL) ;
		value = pTXCANMessage->Msg_len;
		dlc = value ;
	
		if ( MsgType == 1 ) // Extended CAN Message 
		{
			// For Extended type Messages, set IDE=1
			value = (value | 0x80 );
		}
		value = (pTXCANMessage->Rtr)? (value | (1<<6)):((value & ~(1<<6)));
	
		outb(value, (isa_base_addr+offset)) ;

		offset = TBUF+TBUF_DATA ;
		for ( j=0; j < dlc ; j++ )
		{
			value = pTXCANMessage->Data[j] ;
			outb(value, (isa_base_addr+((offset+j)))) ;
		
		}

		offset = TCTRL ;
		value = 0x40;
		outb(value, (isa_base_addr+offset)) ;

		offset = TCMD ;
		value = 0x84;  // PTB 0x10 PTE STB 0x82 TSALL 0x84 for TSONE
		outb(value, (isa_base_addr+offset)) ;

}
/////////////////////////////////////////////////////////////////////////////////////////
//
//isa_dev_tx_ptb_frame
//Description:
//
// This function is called from the pci_dev_write system call where the user selected for PTB buffer type   for  CAN device ISA for CAN(0-3) based on 
// the port selected 
//
//Return:
// void 
///////////////////////////////////////////////////////////////////////////////////////
void isa_dev_tx_ptb_frame(PCANMESSAGE pTXCANMessage)
{
	int j;
	unsigned int value ,dlc ;
	unsigned int offset;
	unsigned int isa_base_addr;
	unsigned char MsgType, tmp ;
	

	isa_base_addr = isabaseaddr[pTXCANMessage->Can_ch];
	

	offset = TCMD ;
	value = 0x00; // PTB 0x00 STB= 0x80
	outb(value, (isa_base_addr+offset)) ;

	MsgType = pTXCANMessage->Msg_type ;
	

	if ( MsgType == 0 ) // Standard CAN Message 
	{
		value = pTXCANMessage->Msg_ID ;
		offset = (TBUF + MSG_ID_1 );
		outb(((value & 0x7F8) >> 3), (isa_base_addr+offset)) ;

		offset = (TBUF + MSG_ID_2 );
		value = ((value & 0x07) << 0x05);
		outb(value, (isa_base_addr+offset)) ;
	}	
	else  // Else it is extended Message 
	{
		value = pTXCANMessage->Msg_ID ;
		offset = (TBUF + MSG_ID_1 );
		tmp = (value >> 21 ) ;
		outb(tmp, (isa_base_addr+offset)) ;

		offset = (TBUF + MSG_ID_2 );
		tmp = (value >> 13 ) & 0xff ;
		outb(tmp, (isa_base_addr+offset)) ;

		offset = (TBUF + MSG_ID_3 );
		tmp = (value >> 5 ) & 0xff ;
		outb(tmp, (isa_base_addr+offset)) ;

		offset = (TBUF + MSG_ID_4 );
		tmp = (value & 0x1f) ;
		tmp = (tmp<<3) ;
		outb(tmp, (isa_base_addr+offset)) ;
	}
	

	offset = (TBUF+TBUF_CTRL) ;
	value = pTXCANMessage->Msg_len;
	dlc = value ;

	if ( MsgType == 1 ) // Extended CAN Message 
	{
		// For Extended type Messages, set IDE=1
		value = (value | 0x80 );
	}
	value = (pTXCANMessage->Rtr)? (value | (1<<6)):((value & ~(1<<6)));
	
	outb(value, (isa_base_addr+offset)) ;

	offset = TBUF+TBUF_DATA ;
	for ( j=0; j < dlc ; j++ )
	{
		value = pTXCANMessage->Data[j] ;
		outb(value, (isa_base_addr+((offset+j)))) ;
	}

	offset = TCMD ;
	value = 0x10;  // PTB 0x10 PTE STB 0x82 TSALL 0x84 for TSONE
	outb(value, (isa_base_addr+offset)) ;

}
/////////////////////////////////////////////////////////////////////////////////////////
//
//pci_dev_tx_stb_frame
//Description:
//
// This function is called from the pci_dev_write system call where the user selected for STB buffer type   for  CAN device PCI for CAN(0-3) based on 
// the port selected 
//
//Return:
// void 
///////////////////////////////////////////////////////////////////////////////////////
void pci_dev_tx_stb_frame(PCANMESSAGE pTXCANMessage)
{
	int j;
	unsigned int value ,dlc ;
	unsigned int offset;
	unsigned char MsgType, tmp;
	void *base_addr;
	base_addr = baseaddr[pTXCANMessage->Can_ch];

	offset = TCMD * 4;
	value = 0x80; // PTB 0x00 // STB 0x80
	writeb(value, (base_addr+offset)) ;

	MsgType = pTXCANMessage->Msg_type ;
	

	if ( MsgType == 0 ) // Standard CAN Message 
	{
		value = pTXCANMessage->Msg_ID ;
		offset = (TBUF + MSG_ID_1 ) * 4;
		writeb(((value & 0x7F8) >> 3), (base_addr+offset)) ;
		offset = (TBUF + MSG_ID_2 ) * 4;
		value = ((value & 0x07) << 0x05);
		writeb(value, (base_addr+offset)) ;
	}
	else  // Else it is extended Message 
	{
		value = pTXCANMessage->Msg_ID ;
		offset = (TBUF + MSG_ID_1 ) * 4;
		tmp = (value >> 21 ) ;
		writeb(tmp, (base_addr+offset)) ;

		offset = (TBUF + MSG_ID_2 ) * 4;
		tmp = (value >> 13 ) & 0xff ;
		writeb(tmp, (base_addr+offset)) ;

		offset = (TBUF + MSG_ID_3 ) * 4;
		tmp = (value >> 5 ) & 0xff ;
		writeb(tmp, (base_addr+offset)) ;

		offset = (TBUF + MSG_ID_4 ) * 4;
		tmp = (value & 0x1f) ;
		tmp = (tmp<<3) ;
		writeb(tmp, (base_addr+offset)) ;
	}
	
	offset = (TBUF+TBUF_CTRL) * 4;
	value = pTXCANMessage->Msg_len;
	dlc = value ;

	if ( MsgType == 1 ) // Extended CAN Message 
	{
		// For Extended type Messages, set IDE=1
		value = (value | 0x80 );
	}

	value = (pTXCANMessage->Rtr)? (value | (1<<6)):((value & ~(1<<6)));
	
	writeb(value, (base_addr+offset)) ;

	offset = TBUF+TBUF_DATA ;
	for ( j=0; j < dlc ; j++ )
	{
		value = pTXCANMessage->Data[j] ;
		writeb(value, (base_addr+((offset+j)*4))) ;
	}

	offset = TCTRL * 4;
	value = 0x40; // STB enable this , TSNEXT for STB 
	writeb(value, (base_addr+offset)) ;

	offset = TCMD * 4;
	value = 0x82; // Enable the TSALL bit
	writeb(value, (base_addr+offset)) ;
}
/////////////////////////////////////////////////////////////////////////////////////////
//
//pci_dev_tx_ptb_frame
//Description:
//
// This function is called from the pci_dev_write system call where the user selected for PTB buffer type   for  CAN device PCI for CAN(0-3) based on 
// the port selected 
//
//Return:
// void 
///////////////////////////////////////////////////////////////////////////////////////
void pci_dev_tx_ptb_frame(PCANMESSAGE pTXCANMessage)
{
	int j;
	unsigned int value ,dlc ;
	unsigned int offset;
	unsigned char MsgType, tmp;
	void *base_addr;
	base_addr = baseaddr[pTXCANMessage->Can_ch];

	offset = TCMD * 4;
	value = 0x00; // PTB 0x00 // STB 0x80
	writeb(value, (base_addr+offset)) ;

	MsgType = pTXCANMessage->Msg_type ;
	

	if ( MsgType == 0 ) // Standard CAN Message 
	{
		value = pTXCANMessage->Msg_ID ;
		
		offset = (TBUF + MSG_ID_1 ) * 4;
		writeb(((value & 0x7F8) >> 3), (base_addr+offset)) ;
		offset = (TBUF + MSG_ID_2 ) * 4;
		value = ((value & 0x07) << 0x05);
		writeb(value, (base_addr+offset)) ;
	}
	else  // Else it is extended Message 
	{
		value = pTXCANMessage->Msg_ID ;
		offset = (TBUF + MSG_ID_1 ) * 4;
		tmp = (value >> 21 ) ;
		writeb(tmp, (base_addr+offset)) ;
		offset = (TBUF + MSG_ID_2 ) * 4;
		tmp = (value >> 13 ) & 0xff ;
		writeb(tmp, (base_addr+offset)) ;
		offset = (TBUF + MSG_ID_3 ) * 4;
		tmp = (value >> 5 ) & 0xff ;
		writeb(tmp, (base_addr+offset)) ;

		offset = (TBUF + MSG_ID_4 ) * 4;
		tmp = (value & 0x1f) ;
		tmp = (tmp<<3) ;
		writeb(tmp, (base_addr+offset)) ;
	}
	

	offset = (TBUF+TBUF_CTRL) * 4;
	value = pTXCANMessage->Msg_len;
	dlc = value ;
	if ( MsgType == 1 ) // Extended CAN Message 
	{
		// For Extended type Messages, set IDE=1
		value = (value | 0x80 );
	}
	value = (pTXCANMessage->Rtr)? (value | (1<<6)):((value & ~(1<<6)));
	writeb(value, (base_addr+offset)) ;

	offset = TBUF+TBUF_DATA ;
	for ( j=0; j < dlc ; j++ )
	{
		value = pTXCANMessage->Data[j] ;
		writeb(value, (base_addr+((offset+j)*4))) ;
	}
	offset = TCMD * 4;
	value = 0x10; // Set the TPE
	writeb(value, (base_addr+offset)) ;
		
}
/////////////////////////////////////////////////////////////////////////////////////////
//
//pci_dev_write
//Description:
//
// This function is a write  system call used for transmision for  CAN device PCI/ISA mode for CAN(0-3) based on 
// the port selected and driver installed for PCI/ISA 
//and it will call based on the write() in user side, 
//copied the CANMESSAGE strcuture from user
//
//Return:
// void 
///////////////////////////////////////////////////////////////////////////////////////
static ssize_t pci_dev_write(struct file *file, const char __user *user_buf, size_t count, loff_t *f_pos)
{
	
	PCANMESSAGE pTXCANMessage =NULL;
//	mutex_lock(&candev.tx0);
	pTXCANMessage = kmalloc(sizeof(CANMESSAGE),GFP_KERNEL);
	memset(pTXCANMessage,0,sizeof(CANMESSAGE));
	if(copy_from_user((PCANMESSAGE)(pTXCANMessage), (user_buf), sizeof(CANMESSAGE)))
	{
		return -EFAULT;
	}

	if(mode== ISA_MODE)
	{
			
		if(pTXCANMessage->Tb_Type == 0 )
		{
                  isa_dev_tx_ptb_frame(pTXCANMessage);
		}
		else
		{
		isa_dev_tx_stb_frame(pTXCANMessage);
		}

	}
	else
	{
		if(pTXCANMessage->Tb_Type == 0 )
		{
                  pci_dev_tx_ptb_frame(pTXCANMessage);
		}
		else
		{
		pci_dev_tx_stb_frame(pTXCANMessage);
		}
	}
	
	if(pTXCANMessage->Can_ch == 0) 
	{
	wait_event_interruptible((candev.write_queue0),Wake_up_fake_Cond_0);
	Wake_up_fake_Cond_0 = 0 ;
		if ( signal_pending(current) )
		{
		return -ERESTARTSYS;
		}
	}
#if 0
	if(pTXCANMessage->Can_ch == 1) 
	{
	wait_event_interruptible((candev.write_queue1),Wake_up_fake_Cond_1);
	Wake_up_fake_Cond_1 = 0 ;
		if ( signal_pending(current) )
		{
		return -ERESTARTSYS;
		}
	}

	if(pTXCANMessage->Can_ch == 2) 
	{
	wait_event_interruptible((candev.write_queue2),Wake_up_fake_Cond_2);
	Wake_up_fake_Cond_2 = 0 ;
		if ( signal_pending(current) )
		{
		return -ERESTARTSYS;
		}
	}

	if(pTXCANMessage->Can_ch == 3) 
	{
	wait_event_interruptible((candev.write_queue3),Wake_up_fake_Cond_3);
	Wake_up_fake_Cond_3 = 0 ;
		if ( signal_pending(current) )
		{
		return -ERESTARTSYS;
		}
	}
#endif
	*f_pos += count;

	kfree(pTXCANMessage);
//	mutex_unlock(&candev.tx0);
	return count ;
}
void pci_can_tx_port(PCANMESSAGE pTXCANMessage)
{
if(mode== ISA_MODE)
	{
			
		if(pTXCANMessage->Tb_Type == 0 )
		{
                  isa_dev_tx_ptb_frame(pTXCANMessage);
		}
		else
		{
		isa_dev_tx_stb_frame(pTXCANMessage);
		}

	}
	else
	{
		if(pTXCANMessage->Tb_Type == 0 )
		{
                  pci_dev_tx_ptb_frame(pTXCANMessage);
		}
		else
		{
		pci_dev_tx_stb_frame(pTXCANMessage);
		}
	}
#if 0	
	if(pTXCANMessage->Can_ch == 0) 
	{
	wait_event_interruptible((candev.write_queue0),Wake_up_fake_Cond_0);
	Wake_up_fake_Cond_0 = 0 ;
		if ( signal_pending(current) )
		{
		return -ERESTARTSYS;
		}
	}
#endif
	
	return;
}
/////////////////////////////////////////////////////////////////////////////////////////
//
//set_baudrate
//Description:
//
// This function set the baudrate for  CAN device ISA for CAN(0-3) based on the CAN Port selected 
//
//Return:
// void 
///////////////////////////////////////////////////////////////////////////////////////
static int set_baudrate(unsigned int base_addr,int baudrate)
{
	unsigned int Tseg_1;
	unsigned int Tseg_2;
	unsigned int SJW;
	unsigned int S_PRESC;
	unsigned int BitTime_0, BitTime_1, BitTime_2;	
	
	
	

	can_init(base_addr);

	switch (baudrate)  // setting actual bus timing
	{                           // all @ 16 Mhz
		case 8://CAN_SPEED_10K: // 37, 11, 64
			Tseg_1 = 37;
			Tseg_2 = 11;
			SJW = 1;
			S_PRESC = 64;
			break;
		case 7://CAN_SPEED_20K:
			Tseg_1 = 21;
			Tseg_2 = 3;
			SJW = 1;
			S_PRESC = 60;
			break;
		case 6://CAN_SPEED_50K:
			Tseg_1 = 17 ;
			Tseg_2 =  2;
			SJW = 1;
			S_PRESC = 29 ;
			break;
		case 5://CAN_SPEED_100K:
			Tseg_1 = 11;
			Tseg_2 = 2;
			SJW = 1;
			S_PRESC = 20;
			break;
		case 4://CAN_SPEED_125K:
			Tseg_1 = 16;
			Tseg_2 = 3;
			SJW = 1;
			S_PRESC = 11;
			break;
		case 3://CAN_SPEED_250K:
			Tseg_1 = 8;
			Tseg_2 = 1;
			SJW = 1;
			S_PRESC = 10;
			break;
		case 2://CAN_SPEED_500K:
			Tseg_1 = 18;
			Tseg_2 = 1;
			SJW = 1;
			S_PRESC = 2;
			break;
		case 1://CAN_SPEED_800K:
			Tseg_1 = 9;
			Tseg_2 = 2;
			SJW = 1;
			S_PRESC = 2;
			break;
		case 0://CAN_SPEED_1M:
			Tseg_1 = 6;
			Tseg_2 = 2;
			SJW = 1;
			S_PRESC = 2;
			break;
		default:
			return -1;
	}

	BitTime_0 = (Tseg_1 ) ;
	//| (SJW << 6); 
	BitTime_1 = (Tseg_2 ) ;
	// | ((Tseg_2 - 1) << 5 );
	BitTime_2 = (SJW) ;
	//| ((Tseg_1) << 4 );


	outb(0x80, (base_addr + (CFG_STAT))) ;
	//msleep(1) ;
	outb(BitTime_0, (base_addr + (BITTIME0))) ;
	//msleep(1) ;
	outb(BitTime_1, (base_addr + (BITTIME1))) ;
	//msleep(1) ;
	outb(BitTime_2, (base_addr + (BITTIME2))) ;
	//msleep(1) ;
	outb(S_PRESC, (base_addr + (SPRESC))) ;
	//outb(S_PRESC, (base_addr + (FPRESC * 4))) ;
	//sleep(2) ;
	outb(0x00, (base_addr + (CFG_STAT))) ;
	//msleep(2) ;
	outb(0xFF, (base_addr+(RTIE))) ;
	//msleep(2) ;

	return 0;


}
/////////////////////////////////////////////////////////////////////////////////////////
//
//pci_dev_ioctl
//Description:
//
// This function is a system call used  for  CAN device PCI/ISA mode for CAN(0-3) based on 
// the port selected and driver installed for PCI/ISA 
//and it will call based on the ioctl() in user side
//
//
//Return:
// void 
///////////////////////////////////////////////////////////////////////////////////////
long pci_dev_ioctl(struct file* file, unsigned int pci_cmd, unsigned long pci_arg)
{
	int return_value = 0,count;
	unsigned int isa_base_addr;
	void * base_addr;
	CANCONFIG can_config;
	unsigned int can_id=0;
	CANMESSAGE pRXCANMessage ;
	PCANMESSAGE pTXCANMessage =NULL ;
	can_device_stats pstats;
	unsigned char data[16];	
	PORTCONFIG pPortConfig;
	CANRW    pCANRW;
	CANADDR  pCANAddr;
	can_dev *candev_p = (can_dev*)file->private_data ;
	
		

	switch ( pci_cmd )
	{
		
		case IOCTL_TX_1 :
//		mutex_lock(&candev_p->tx1);
		pTXCANMessage = kmalloc(sizeof(CANMESSAGE),GFP_KERNEL);
		memset(pTXCANMessage,0,sizeof(CANMESSAGE));
		if(copy_from_user((PCANMESSAGE)(pTXCANMessage), (CANMESSAGE*)(pci_arg), sizeof(CANMESSAGE)))
		{
			return -EFAULT;
		}
		pci_can_tx_port(pTXCANMessage);
		if(pTXCANMessage->Can_ch == 1) 
		{
		wait_event_interruptible((candev_p->write_queue1),Wake_up_fake_Cond_1);
		Wake_up_fake_Cond_1 = 0 ;
			if ( signal_pending(current) )
			{
			return -ERESTARTSYS;
			}
		}
		kfree(pTXCANMessage);
//		mutex_unlock(&candev_p->tx1);
		return sizeof(CANMESSAGE);
		break;

		case IOCTL_TX_2 :
//		mutex_lock(&candev_p->tx2);
		pTXCANMessage = kmalloc(sizeof(CANMESSAGE),GFP_KERNEL);
		memset(pTXCANMessage,0,sizeof(CANMESSAGE));
		if(copy_from_user((PCANMESSAGE)(pTXCANMessage), (CANMESSAGE*)(pci_arg), sizeof(CANMESSAGE)))
		{
			return -EFAULT;
		}
		pci_can_tx_port(pTXCANMessage);
		if(pTXCANMessage->Can_ch == 2) 
		{
		wait_event_interruptible((candev_p->write_queue2),Wake_up_fake_Cond_2);
		Wake_up_fake_Cond_2 = 0 ;
			if ( signal_pending(current) )
			{
			return -ERESTARTSYS;
			}
		}
		kfree(pTXCANMessage);
//		mutex_unlock(&candev_p->tx2);
		return sizeof(CANMESSAGE);
		break; 
		case IOCTL_TX_3 :
//		mutex_lock(&candev_p->tx3);
		pTXCANMessage = kmalloc(sizeof(CANMESSAGE),GFP_KERNEL);
		memset(pTXCANMessage,0,sizeof(CANMESSAGE));
		if(copy_from_user((PCANMESSAGE)(pTXCANMessage), (CANMESSAGE*)(pci_arg), sizeof(CANMESSAGE)))
		{
			return -EFAULT;
		}
		pci_can_tx_port(pTXCANMessage);
		if(pTXCANMessage->Can_ch == 3) 
		{
		wait_event_interruptible((candev_p->write_queue3),Wake_up_fake_Cond_3);
		Wake_up_fake_Cond_3 = 0 ;
			if ( signal_pending(current) )
			{
			return -ERESTARTSYS;
			}
		}
		kfree(pTXCANMessage);
//		mutex_unlock(&candev_p->tx3);
		return sizeof(CANMESSAGE);
		break;
		case IOCTL_BAUDRATE : // Set BAUD-RATE 
			//read the register and store to reg_val.value
			//Set baudrate	 
			if(copy_from_user((CANCONFIG*)(&can_config), (CANCONFIG*)pci_arg, sizeof(CANCONFIG)))
			{
				return -EFAULT;
			}
			
			if(mode==ISA_MODE)
			{
				isa_base_addr = isabaseaddr[can_config.Can_ch];
				
				set_baudrate( isa_base_addr, can_config.BaudRate);	
			}
			else
			{
				base_addr = baseaddr[can_config.Can_ch];
				
				pci_set_baudrate( base_addr, can_config.BaudRate);	
			}	
			DataEmpty(candev_p);			
				
			break;
		case IOCTL_RX_0: // Data receive for CAN 0 (ISA/PCI) mode to application layer
		
		
	
			if((count = DataDequeue0(candev_p,data)) != -1)
			{
				pRXCANMessage.Can_ch = 0;
				pRXCANMessage.Rtr     = data[0];
				if((data[6] & 0x80) == 0x80) // Check for IDE Bit
				{
					pRXCANMessage.Msg_type = data[1];
					can_id = (data[2]<<21);
					can_id = (can_id | (data[3]<<13));
					can_id = (can_id |(data[4]<<5));
					can_id = (can_id |(data[5]>>3));
					pRXCANMessage.Msg_ID  = can_id;
				
				}
				else
				{
					pRXCANMessage.Msg_type = data[1];
					can_id = (data[4]<<3) ;
					can_id = (can_id | (data[5]>>5));
					pRXCANMessage.Msg_ID  = can_id;
				}	
				
				pRXCANMessage.Msg_len = (data[6]& (0x0F));
					
				memmove(&pRXCANMessage.Data,&(data[7]),(data[6]& (0x0F)));
				
				
				if(copy_to_user((CANMESSAGE*)(pci_arg), (CANMESSAGE*)(&pRXCANMessage), sizeof(CANMESSAGE)))
				{
				    return -EFAULT;
				}	
				return_value = sizeof(CANMESSAGE);
				
				
			}
			else
			{
			    return -1;
			}
			

			break;
		case IOCTL_RX_1: // Data receive for CAN 1 (ISA/PCI) mode to application layer
			
			if((count = DataDequeue1(candev_p,data)) != -1)
			{
				pRXCANMessage.Can_ch = 1;
				pRXCANMessage.Rtr     = data[0];
				if((data[6] & 0x80) == 0x80) // Check for IDE Bit
				{
					pRXCANMessage.Msg_type = data[1];
					can_id = (data[2]<<21);
					can_id = (can_id | (data[3]<<13));
					can_id = (can_id |(data[4]<<5));
					can_id = (can_id |(data[5]>>3));
					pRXCANMessage.Msg_ID  = can_id;
				
				}
				else
				{
					pRXCANMessage.Msg_type = data[1];
					can_id = (data[4]<<3) ;
					can_id = (can_id | (data[5]>>5));
					pRXCANMessage.Msg_ID  = can_id;
				}	
				
				pRXCANMessage.Msg_len = (data[6]& (0x0F));
					
				memmove(&pRXCANMessage.Data,&(data[7]),(data[6]& (0x0F)));
				
				
				if(copy_to_user((CANMESSAGE*)(pci_arg), (CANMESSAGE*)(&pRXCANMessage), sizeof(CANMESSAGE)))
				{
				    return -EFAULT;
				}	
				return_value = sizeof(CANMESSAGE);
				
			}
			else
			{
			    return -1;
			}
			

			break;
		case IOCTL_RX_2:// Data receive for CAN 2 (ISA/PCI) mode to application layer
			
			if((count = DataDequeue2(candev_p,data)) != -1)
			{
				pRXCANMessage.Can_ch = 2;
				pRXCANMessage.Rtr     = data[0];
				if((data[6] & 0x80) == 0x80) // Check for IDE Bit
				{
					pRXCANMessage.Msg_type = data[1];
					can_id = (data[2]<<21);
					can_id = (can_id | (data[3]<<13));
					can_id = (can_id |(data[4]<<5));
					can_id = (can_id |(data[5]>>3));
					pRXCANMessage.Msg_ID  = can_id;
				
				}
				else
				{
					pRXCANMessage.Msg_type = data[1];
					can_id = (data[4]<<3) ;
					can_id = (can_id | (data[5]>>5));
					pRXCANMessage.Msg_ID  = can_id;
				}	
				
				pRXCANMessage.Msg_len = (data[6]& (0x0F));
					
				memmove(&pRXCANMessage.Data,&(data[7]),(data[6]& (0x0F)));
				
				
				if(copy_to_user((CANMESSAGE*)(pci_arg), (CANMESSAGE*)(&pRXCANMessage), sizeof(CANMESSAGE)))
				{
				    return -EFAULT;
				}	
				return_value = sizeof(CANMESSAGE);
				
			}
			else
			{
			    return -1;
			}
			

			break;
		case IOCTL_RX_3: // Data receive for CAN 3 (ISA/PCI) mode to application layer
			
			
			if((count = DataDequeue3(candev_p,data)) != -1)
			{
				pRXCANMessage.Can_ch = 3;
				pRXCANMessage.Rtr     = data[0];
				if((data[6] & 0x80) == 0x80) // Check for IDE Bit
				{
					pRXCANMessage.Msg_type = data[1];
					can_id = (data[2]<<21);
					can_id = (can_id | (data[3]<<13));
					can_id = (can_id |(data[4]<<5));
					can_id = (can_id |(data[5]>>3));
					pRXCANMessage.Msg_ID  = can_id;
				
				}
				else
				{
					pRXCANMessage.Msg_type = data[1];
					can_id = (data[4]<<3) ;
					can_id = (can_id | (data[5]>>5));
					pRXCANMessage.Msg_ID  = can_id;
				}	
				
				pRXCANMessage.Msg_len = (data[6]& (0x0F));
					
				memmove(&pRXCANMessage.Data,&(data[7]),(data[6]& (0x0F)));
				
				
				if(copy_to_user((CANMESSAGE*)(pci_arg), (CANMESSAGE*)(&pRXCANMessage), sizeof(CANMESSAGE)))
				{
				    return -EFAULT;
				}	
				return_value = sizeof(CANMESSAGE);
				
			}
			else
			{
			    return -1;
			}
			

			break;
		case IOCTL_DEV_STATS_0: // device stats for CAN 0 (ISA/PCI) mode to application layer
			
			pstats = candev_p->can_stats[CAN_0];
			if(copy_to_user((can_device_stats*)(pci_arg), (can_device_stats*)(&pstats), sizeof(can_device_stats)))
				{
				    return -EFAULT;
				}	
			return_value = sizeof(can_device_stats);
			break;
		case IOCTL_DEV_STATS_1:// device stats for CAN 1 (ISA/PCI) mode to application layer
			pstats = candev_p->can_stats[CAN_1];
			if(copy_to_user((can_device_stats*)(pci_arg), (can_device_stats*)(&pstats), sizeof(can_device_stats)))
				{
				    return -EFAULT;
				}	
			return_value = sizeof(can_device_stats);
			break;
		case IOCTL_DEV_STATS_2: // device stats for CAN 2 (ISA/PCI) mode to application layer
			pstats = candev_p->can_stats[CAN_2];
			if(copy_to_user((can_device_stats*)(pci_arg), (can_device_stats*)(&pstats), sizeof(can_device_stats)))
				{
				    return -EFAULT;
				}	
			return_value = sizeof(can_device_stats);
			break;
		case IOCTL_DEV_STATS_3: // device stats for CAN 3 (ISA/PCI) mode to application layer
			pstats = candev_p->can_stats[CAN_3];
			if(copy_to_user((can_device_stats*)(pci_arg), (can_device_stats*)(&pstats), sizeof(can_device_stats)))
				{
				    return -EFAULT;
				}	
			return_value = sizeof(can_device_stats);
			break;
		case IOCTL_DIO_CONFIG: // DIO configuration for (ISA/PCI) mode from  application layer
			if(copy_from_user((PORTCONFIG*)(&pPortConfig), (PORTCONFIG*)pci_arg, sizeof(PORTCONFIG)))
			{
					return -EFAULT;
			}
			if(mode == ISA_MODE)
			{
				if(pPortConfig.Port ==0)
				{
					if(pPortConfig.Control==0){ // input mode 
					outb(0, (isa_dio_base_addr+DIO_DIRECTION_CTRL)) ;	
					}
					else{
					outb(1, (isa_dio_base_addr+DIO_DIRECTION_CTRL)) ;
					}
				}
				if(pPortConfig.Port ==1)
				{
				if(pPortConfig.Control==0) // input mode 
				{
				outb(0, (isa_dio_base_addr+DIO_DIRECTION_CTRL)) ;
				
				}			
				else
				{
				outb(2, (isa_dio_base_addr+DIO_DIRECTION_CTRL)) ;
					
				}			
				}
			}
			else
			{
				if(pPortConfig.Port ==0)
				{
					if(pPortConfig.Control==0){ // input mode 
					writeb(0, (dio_baddr+(DIO_DIRECTION_CTRL*4))) ;	
				}
				else{
				writeb(1, (dio_baddr+(DIO_DIRECTION_CTRL*4))) ;
				}
				}
				if(pPortConfig.Port ==1)
				{
				if(pPortConfig.Control==0) // input mode 
				{
				writeb(0, (dio_baddr+(DIO_DIRECTION_CTRL*4))) ;
				
				}			
				else
				{
				writeb(2, (dio_baddr+(DIO_DIRECTION_CTRL*4))) ;
					
				}			
				}
			}
			break;
		case IOCTL_DEV_READ: // device read from CAN (0-3) (ISA/PCI) mode to application layer
			if(copy_from_user((CANRW*)(&pCANRW), (CANRW*)pci_arg, sizeof(CANRW)))
			{
				return -EFAULT;
			}
			
			if(mode == ISA_MODE)
			{
			pCANRW.data = inb(isabaseaddr[pCANRW.Can_ch]+(pCANRW.offset));
			}
			else
			{
			pCANRW.data = readb(baseaddr[pCANRW.Can_ch]+(pCANRW.offset*4));
			}

			if(copy_to_user((CANRW*)(pci_arg), (CANRW*)(&pCANRW), sizeof(CANRW)))
				{
				    return -EFAULT;
				}	
			return_value = sizeof(CANRW);
			break;
		case IOCTL_DEV_WRITE:// device write to CAN (0-3) (ISA/PCI) mode from application layer
			if(copy_from_user((CANRW*)(&pCANRW), (CANRW*)pci_arg, sizeof(CANRW)))
			{
				return -EFAULT;
			}
			if(mode == ISA_MODE)
			{
			outb(pCANRW.data, (isabaseaddr[pCANRW.Can_ch]+(pCANRW.offset))) ;	
			}
			else
			{
			writeb(pCANRW.data, (baseaddr[pCANRW.Can_ch]+(pCANRW.offset*4))) ;	
			}

			return_value = sizeof(CANRW);
			break;
		case IOCTL_DEV_BASE_ADDR : // Set Base Address 
			
			if(copy_from_user((CANADDR*)(&pCANAddr), (CANADDR*)pci_arg, sizeof(CANADDR)))
			{
				return -EFAULT;
			}
			isa_base_addr_val = pCANAddr.base_addr;
			//printk("isa_base_addr_val %x\n",isa_base_addr_val);
			init_isa();
			break;
		case IOCTL_DEV_DIO_BASE : // Set DIO ADDR 
			if(copy_from_user((CANADDR*)(&pCANAddr), (CANADDR*)pci_arg, sizeof(CANADDR)))
			{
				return -EFAULT;
			}
			isa_dio_base_addr = pCANAddr.DIO_addr;
			//printk("isa_dio_base_addr %x\n",isa_dio_base_addr);
			break;		
		default:
			break;

	}
	return ( return_value ) ;
}

struct file_operations pci_dev_fops = {
	.owner = THIS_MODULE,
	.open = pci_dev_open,
	.release = pci_dev_close,
	.write = pci_dev_write,
	.unlocked_ioctl = pci_dev_ioctl

};

static int init_pci(void)
{
	unsigned long mmio_start, mmio_end, mmio_len, mmio_flags;
	void *ioaddr;
	void *base_addr;
	int i;
	//memset(&candev,0,sizeof(candev));
	pci_dev = pci_get_device(PCICAN_VENDER_ID, PCICAN_DEVICE_ID, NULL);
	if(pci_dev)
	{
		if(pci_enable_device(pci_dev))
		{
			printk(KERN_INFO "Failed to enable device\n");
			return -ENODEV;
		}
		else
		{
			printk("\nPCI-CAN Device is enabled\n");
		}
	}
	else
	{	
		printk(KERN_INFO "Device not found\n");
		return -ENODEV;
	}
	if(pci_request_regions(pci_dev, "PCI_DRV"))
	{
		printk("Failed to accquire the memory resources\n");
		goto clean_disable;
	}
	else 
	{
		printk("PCI-CAN : Accquired the PCI memory regions\n");
	}

	pci_set_master(pci_dev);

	i=0 ; // Single BAR address
	mmio_start = pci_resource_start(pci_dev, i);
	mmio_end = pci_resource_end(pci_dev, i);
	mmio_len = pci_resource_len(pci_dev, i);
	mmio_flags = pci_resource_flags(pci_dev, i);
	
	if ( mmio_start > 0 ) 
	{
		ioaddr = ioremap(mmio_start, mmio_len);
		if(ioaddr == NULL)
		{
			printk("Failed to remap the memory region#%d\n", i);
			goto clean_regions;
		}

		base_addr = ioaddr;
		bar_base_addr = base_addr + 1048 ; // For SysFS 

		for(i=0;  i<MAX_DEV_SUPPORT; i++)
		{
			baseaddr[i] = base_addr + ((i+1)*1024) ;
			//printk("baseaddr[%x] 0x%x \n",i,baseaddr[i]);
			
		}
		candev.int_level = pci_dev->irq;
		printk("irq level %x\n",candev.int_level);
		/* The last block is used for DIO and FPGA Major/minor version */
		dio_base_addr = base_addr + ((i+1)*1024) ;
		

		dio_baddr = dio_base_addr;

		fpga_board_addr = base_addr + ((i+2)*1024) ;
		
	}
	
	
	return 0 ;


clean_regions:
	pci_release_regions(pci_dev);
	LOG("Released PCI regions\n");
clean_disable:
	pci_disable_device(pci_dev);
	LOG("PCI-CAN Device disabled\n");
	return -EINVAL;

} 

static struct class *pci_class;

static struct kobj_attribute dioA_attribute =
__ATTR(dioA, 0666, DIOA_read, DIOA_write);


static struct kobj_attribute dioB_attribute =
__ATTR(dioB, 0666, DIOB_read, DIOB_write);



static struct kobj_attribute fpga_ver_attribute =
__ATTR(fpga_ver, 0444, fpga_ver_read, NULL);

static struct kobj_attribute board_ver_attribute =
__ATTR(board_ver, 0444, board_ver_read, NULL);




static struct attribute *attrs[] = {
	&dioA_attribute.attr,
	&dioB_attribute.attr,
	&fpga_ver_attribute.attr,
	&board_ver_attribute.attr,
        NULL,   /* need to NULL terminate the list of attributes */
};
static struct attribute_group attr_group = {
	                .attrs = attrs,
};

static struct kobject *baraddr_kobj;


static int init_isa(void)
{
	int i;

	

	for(i=0;  i<MAX_DEV_SUPPORT; i++)
	{
		isabaseaddr[i] = isa_base_addr_val + (i*0x100) ;
		//printk("isa Address %x\n",isabaseaddr[i]);
	}
	
	isa_fpga_board_addr = isa_base_addr_val + (i*0x100) ;
	return 0 ;
} 

static struct class *isa_class;
static int __init jnmmcan4lp_driver_init(void)
{
	int status;
	char dev_name[20];
	int i=0;
	int retval;
	memset(&candev,0,sizeof(candev));
	if(mode==ISA_MODE)   // ISA mode
	{	
#if 0		
		if ( init_isa() < 0 )
		{
			printk("Enable to initialize the ISA device.\n") ;
			return -ENODEV ;
		}
#endif
		baraddr_kobj = kobject_create_and_add("dsc_can", kernel_kobj);
		if (!baraddr_kobj)
			return -ENOMEM;

		/* Create the files associated with this kobject */
		status = sysfs_create_group(baraddr_kobj, &attr_group);
		if (status)
			kobject_put(baraddr_kobj);


		if((status = register_chrdev(ISA_DRV_MAJOR, ISA_DRV_NAME, &pci_dev_fops)) < 0)
		{
			printk(KERN_INFO "%s: Failed to register ISA CAN char driver.\n", DRV_NAME);
			return status;
		}

		isa_class = class_create(THIS_MODULE, ISA_DRV_NAME);
		if (IS_ERR(isa_class))
			return PTR_ERR(isa_class);

		sprintf(dev_name,"%s%d",ISA_DRV_NAME,i);
		device_create(isa_class, NULL, MKDEV(ISA_DRV_MAJOR, i),
		                      NULL, dev_name);

		printk("irq %x \n",irq);
		retval = request_irq(irq, (void *)&JNMM_ISA_Handler, IRQF_SHARED, ISA_DRV_NAME,(void *)&candev);
		if(retval)
		{
			printk("Error in registering the interrupt handler\n");
			return retval;
		}
		else
		printk("Registered the interrupt handler \n");
		printk(KERN_INFO "%s: Device initialization successful.\n", ISA_DRV_NAME);
		
	}
	else // PCI mode
	{
		
		if ( init_pci() < 0 )
		{
			printk("Enable to initialize the PCI device.\n") ;
			return -ENODEV ;
		}
		baraddr_kobj = kobject_create_and_add("dsc_can", kernel_kobj);
		if (!baraddr_kobj){
		  printk("oops!! no object create\n");	
		  return -ENOMEM;
		}

		/* Create the files associated with this kobject */
		status = sysfs_create_group(baraddr_kobj, &attr_group);
		if (status){
			printk("%d : oops!! no sysfs_create_group \n", status);
			kobject_put(baraddr_kobj);
		}

		if((status = register_chrdev(DRV_MAJOR, DRV_NAME, &pci_dev_fops)) < 0)
		{
			printk(KERN_INFO "%s: Failed to register PCI CAN char driver.\n", DRV_NAME);
			return status;
		}

		pci_class = class_create(THIS_MODULE, DRV_NAME);
		if (IS_ERR(pci_class))
			return PTR_ERR(pci_class);

		{
			sprintf(dev_name,"%s%d",DRV_NAME,i);
			device_create(pci_class, NULL, MKDEV(DRV_MAJOR, i),
		                      NULL, dev_name);
		}
#if 1		
		retval = request_irq(candev.int_level, (void *)&JNMM_PCI_Handler, IRQF_SHARED, DRV_NAME,(void *)&candev);
		if(retval)
		{
			printk("Error in registering the interrupt handler\n");
			return retval;
		}
		else
		printk("Registered the interrupt handler \n");
#endif
	
		printk(KERN_INFO "%s: Device initialization successful.\n", DRV_NAME);
		
	}
	// Initialize the Write Queue for TX wait/wake up for tx completion
	init_waitqueue_head(&candev.write_queue0);
	init_waitqueue_head(&candev.write_queue1);
	init_waitqueue_head(&candev.write_queue2);
	init_waitqueue_head(&candev.write_queue3);
	mutex_init(&candev.tx0);
	mutex_init(&candev.tx1);
	mutex_init(&candev.tx2);
	mutex_init(&candev.tx3);
	return 0;
}

static void __exit jnmmcan4lp_driver_cleanup(void)
{
	int i=0 ;	
	if(mode==ISA_MODE)   // ISA mode
	{
		
		
		printk("irq %x \n",irq);
		LOG("Unregistered the Device\n");
		free_irq(irq,(void *)&candev);
		kobject_put(baraddr_kobj);

		/* Remove the device while exiting from the driver*/
		device_destroy(isa_class,  MKDEV(ISA_DRV_MAJOR, i));
	
		class_destroy(isa_class) ;

		/* Unregister the device */
		unregister_chrdev(ISA_DRV_MAJOR, ISA_DRV_NAME);
		
		
	}
	else // PCI- mode
	{

		free_irq(candev.int_level,(void *)&candev);
		printk(KERN_INFO "Device cleaning up started\n");
		LOG("Unregistered the Device\n");
		pci_release_regions(pci_dev);
		LOG("Released PCI regions\n");
		pci_disable_device(pci_dev);
		LOG("Device disabled\n");

		device_destroy(pci_class,  MKDEV(DRV_MAJOR, i));
		class_destroy(pci_class) ;

		/* Unregister the device */
		unregister_chrdev(DRV_MAJOR, DRV_NAME);
		sysfs_remove_group(baraddr_kobj, &attr_group);
		kobject_put(baraddr_kobj);

		printk(KERN_INFO "Device cleaning over\n");
	}
}

module_init(jnmmcan4lp_driver_init);
module_exit(jnmmcan4lp_driver_cleanup);

MODULE_AUTHOR("SenthilRaj D ,Prabhakar Vinayagam, AMI-INDIA.");
MODULE_DESCRIPTION("JNMMCAN4LP PCI CAN driver");
MODULE_LICENSE("GPL");
